<?php

// $Id: newsletter_class.php,v 1.8 2011-04-11 14:01:47 calicant Exp $

// numero di email mostrate per default
define ("NEWSLETTER_NMAIL_PER_PAGE", 50);

// largezza delle mail di tipo testo
define ("NEWSLETTER_DEFAULT_MAIL_WIDTH", 72);

// codici d'errore ritornati in caso di fallita instanzione
define ("NEWSLETTER_ERROR_CODE_CONNH", 1);
define ("NEWSLETTER_ERROR_CODE_USER", 2);


class Newsletter {


    var $_nl_connh;
    var $_nl_user;
    var $_nl_user_id;
    var $_nl_error;
    var $_nl_last_error;

    var $statusError;

    function Newsletter($connh, $user) {

        $this->statusError = 0;
        $this->_nl_connh = $connh;
        $this->_nl_user = $user;
        $usertable = $_SESSION['PRISCILLA_SESSION']->getvalue('usertable');
        $this->_nl_user_id = $usertable['id'];
        $this->_nl_error = false;
        $this->_nl_last_error = '';


        if (!isset($connh) || !$connh) {
            $this->statusError = NEWSLETTER_ERROR_CODE_CONNH;
            return;
        }

        if (!isset($user) || trim($user) == '') {
            $this->statusError = NEWSLETTER_ERROR_CODE_USER;
            return;
        }

    } // Newsletter


    function outputComposeForm() {

        define ("NEWSLETTER_COMPOSE_FIELD_ABSTRACT", "abstract");


        $l_compose_area_tematica = NEWSLETTER_COMPOSE_AREA;
        $l_compose_data_inizio = NEWSLETTER_COMPOSE_INIT_DATA;
        $l_compose_from_date = NEWSLETTER_COMPOSE_DATE_FROM;
        $l_compose_to_date = NEWSLETTER_COMPOSE_DATE_TO;
        $l_title_send_form = NEWSLETTER_COMPOSE_SEND_FORM;
        $l_compose_elenco_news =
                "<strong>" .
                NEWSLETTER_COMPOSE_NEWS_LIST .
                "</strong>" .
                "<br><em>(" .
                NEWSLETTER_COMPOSE_NEWS_LIST1 . "; " .
                NEWSLETTER_COMPOSE_NEWS_LIST2 .
                ")</em> " .
                NEWSLETTER_SELECT_ALL .
                "<input name=\"setAll\" type=\"checkbox\" onclick=\"checkAllNews('fnewslettercomposenews', this.checked)\" id=\"setAll\" class=\"insert_area\">\n"; 

        $l_compose_intestazione_nl = NEWSLETTER_COMPOSE_HEADER;
        $l_compose_piede_nl = NEWSLETTER_COMPOSE_FOOTER;
        $l_compose_created_on = NEWSLETTER_COMPOSE_CREATED_ON;
        $l_compose_newsletter_name = NEWSLETTER_COMPOSE_NL_NAME;
        $l_compose_nl_load = NEWSLETTER_COMPOSE_NL_LOAD;
        $l_compose_no_newsletter_saved = NEWSLETTER_COMPOSE_NO_SAVED_NL;
        $l_compose_newsletter_desc = NEWSLETTER_COMPOSE_DESC;
        $l_compose_newsletter_delete_message = NEWSLETTER_COMPOSE_DELETE_MESSAGE;
        $l_compose_main_title = NEWSLETTER_COMPOSE_MAIN_TITLE;
        $l_compose_no_area = NEWSLETTER_COMPOSE_NO_AREA;
        $l_compose_all_areas = NEWSLETTER_COMPOSE_ALL_AREAS;
        $l_select_news = NEWSLETTER_SELECT_NEWS;
 
        $b_compose_newsletter_save = NEWSLETTER_COMPOSE_SAVE;
        $b_compose_news_cerca = NEWSLETTER_COMPOSE_FIND;
        $b_compose_newsletter_delete = NEWSLETTER_COMPOSE_DELETE;

        $a_select_news = array(
            "node_all" => NEWSLETTER_NODE_TYPE_ALL,
            "node_nodes_news" => NEWSLETTER_NODE_TYPE_NODES_NEWS,
            "node_nodes" => NEWSLETTER_NODE_TYPE_NODES,
            "node_news" => NEWSLETTER_NODE_TYPE_NEWS
        );

        $s_select_news = "<select class=\"insert_area\" name=\"newsletter[node_type]\" size=\"1\">\n";
        foreach ($a_select_news as $n=>$m) {
            $is_selected = $_POST['newsletter']['node_type'] == $n ? "selected" : "";
            $s_select_news .= "<option $is_selected value=\"" . $n ."\">" . $m . "</option>\n";
        }
        $s_select_news .= "</select>\n";


        // aree tematiche
        $a_aree_tematiche = $this->_getAreeTematiche();

        // se non ci sono areee tematiche si finisce qui
        if (!count($a_aree_tematiche)) {
            $this->_nl_error = true;
            $this->_nl_last_error = NEWSLETTER_COMPOSE_NO_AREA;
            $this->outError();
            $this->_output_tomainpanel();
            return;
        }

        if (isset($_POST['newsletter']['compose_areatematica']))
            $current_area = $this->clear_specials($_POST['newsletter']['compose_areatematica'], '');
        else
	        $current_area = "default";


        $onschange = "onChange=\"document.forms.fnewslettercomposenews.submit();\"";

        $s_aree_tematiche = "<select size=\"1\" class=\"insert_area\" name=\"newsletter[compose_areatematica]\" $onschange>\n";

        // tutte le aree tematiche

        $areatematicanoapic = $this->clear_specials($_POST['newsletter']['compose_areatematica'], '');

        $is_selected = $areatematicanoapic == "default" ? "selected" : "";            
        $s_aree_tematiche .= "<option $is_selected value=\"default\">-- " . $l_compose_all_areas . " --</option>\n";
        
        foreach ($a_aree_tematiche as $at) {

            $at = stripslashes($at);
            $sat = $this->clear_specials(trim($at), '');
            
//            echo $areatematicanoapic . " ****** $sat<br />";


            $is_selected = $areatematicanoapic == $sat ? "selected" : "";            
            $s_aree_tematiche .= "<option $is_selected value=\"$sat\">$at</option>\n";
        } // foreach

        $s_aree_tematiche .= "</select>\n";


        $ctime = time();

        // selezione delle newsletter salvate
        $a_saved_newsletters = $this->_getSavedNewsletters($current_area);

        // se abbiamo gia' un nome di newsletter
        if ($_POST['newsletter']['compose_savednl'])
            $newsletter_automatic_name = $a_saved_newsletters[$_POST['newsletter']['compose_savednl']];
        // nome_automatico della newsletter
        else 
            // modifica di antonio: applico la funzione clear_specials (vedi in fondo)
            // per evitare cazzi con apostrofi e altri caratteri strani
            //$newsletter_automatic_name = str_replace(" ", "_", stripslashes($current_area)) . "_" . date("Y", $ctime) . "-" . date("m", $ctime) . "-" . date("d", $ctime);
            $newsletter_automatic_name = $this->clear_specials($current_area, '') . "_" . date("Y", $ctime) . "-" . date("m", $ctime) . "-" . date("d", $ctime);

 
        if (!count($a_saved_newsletters))
            $s_saved_newsletters = $l_compose_no_newsletter_saved;
        else {

            $s_saved_newsletters =
                "<select size=\"1\" class=\"insert_area\" name=\"newsletter[compose_savednl]\" $onschange>\n" .
                "<option value=\"0\"></option>\n";

            $saved_nl_id = 0;

            foreach ($a_saved_newsletters as $nlid => $nlname) {


                $is_selected = $_POST['newsletter']['compose_savednl'] == $nlid ? "selected" : "";

                // questo per tener conto del caso di newsletter appena salvata di cui si ha solo il nome
                // e manca ancora l'id...
                // captain crunch rulez!

//                if ($_POST['nlcomposehavetosave'] == 1)
                // esteso perche' carichi la newsletter anche se non siamo in salvataggio

                    if ($is_selected == "")
                        $is_selected = $newsletter_automatic_name == $nlname ? "selected" : "";

                if ($is_selected == "selected")
                    $saved_nl_id = $nlid;

                $s_saved_newsletters .= "<option $is_selected value=\"$nlid\">$nlname ($nlid)</option>\n";

            } // foreach
            $s_saved_newsletters .= "</select>\n";
        } // else


        // se esiste una corrispondenza con una newsletter salvata, si caricano le info
        // e si sovrascrivono info da post
        if ($saved_nl_id) {
            $nldata = $this->_getNewsletterSaved($saved_nl_id);

            // se si e' espressamente cambiato le date
            // non sovrascivo del date da post con quelle salvate
            if ($_POST['nlcomposefind'] == 1) {
                foreach ($nldata as $k=>$v)
                    if (strpos($k, "datafrom_") !== false || strpos($k, "datato_") !== false)
                        unset($nldata[$k]);
            }

            foreach ($nldata as $k=>$v)
                if ($k == "compose_header" || $k == "compose_footer")
                    $_POST['newsletter'][$k][$current_area] = $v;
                else
                    $_POST['newsletter'][$k] = $v;
        }
        else {
            // occorre azzerare certe cose che arrivano da post se la newsltter e' vuota
            unset($_POST['newsletter']['compose_newsletterdesc']);
            unset($_POST['newsletter']['compose_include_page']);
            unset($_POST['newsletter']['compose_abstract']);
            unset($_POST['newsletter']['compose_header']);
            unset($_POST['newsletter']['compose_footer']);            
        }

        // data iniziale

        $currentyear = date ("Y", $ctime);

        // la data corrente come datato di default
        if (!isset($_POST['newsletter']['datafrom_day'])) {

            $year = $currentyear;
            $lastmonth = date("m", $ctime);

            $_POST['newsletter']['datafrom_day'] = "01";
            $_POST['newsletter']['datafrom_month'] = $lastmonth;
            $_POST['newsletter']['datafrom_year'] = $year;

            $_POST['newsletter']['datato_month'] = $lastmonth;
            $_POST['newsletter']['datato_year'] = $year;


            // calcolo dell'ultimo giorno del mese
            for ($lastday = 31; $lastday > 27; $lastday--)
                if(checkdate ($lastmonth, $lastday, $year))
                    break;

            $_POST['newsletter']['datato_day'] = $lastday;
        }


        $datafrom = "<select size=\"1\" class=\"insert_area\"  name=\"newsletter[datafrom_day]\" size=\"1\">\n";
        $datato = "<select size=\"1\" class=\"insert_area\"  name=\"newsletter[datato_day]\" size=\"1\">\n";


        for ($i = 1; $i < 32; $i++) {
            if ($i < 10)
                $si = "0" . $i;
            else
                $si = $i;
            $is_df_selected = $_POST['newsletter']['datafrom_day'] == $i ? "selected" : "";
            $is_dt_selected = $_POST['newsletter']['datato_day'] == $i ? "selected" : "";

            $datafrom .= "<option $is_df_selected value=\"$si\">$si</option>\n";
            $datato .= "<option $is_dt_selected value=\"$si\">$si</option>\n";
        }


        $datafrom .= "</select>\n<select class=\"insert_area\" name=\"newsletter[datafrom_month]\" size=\"1\">\n";
        $datato .= "</select>\n<select class=\"insert_area\" name=\"newsletter[datato_month]\" size=\"1\">\n";


        for ($i = 1; $i < 13; $i++) {
            if ($i < 10)
                $si = "0" . $i;
            else
                $si = $i;
            $is_df_selected = $_POST['newsletter']['datafrom_month'] == $i ? "selected" : "";
            $is_dt_selected = $_POST['newsletter']['datato_month'] == $i ? "selected" : "";

            $datafrom .= "<option $is_df_selected value=\"$si\">$si</option>\n";
            $datato .= "<option $is_dt_selected value=\"$si\">$si</option>\n";
        }   

        $datafrom .= "</select>\n<select class=\"insert_area\" name=\"newsletter[datafrom_year]\" size=\"1\">\n";
        $datato .= "</select>\n<select $onshchange class=\"insert_area\" name=\"newsletter[datato_year]\" size=\"1\">\n";


        for ($i = 2000; $i <= $currentyear; $i++) {
            $is_df_selected = $_POST['newsletter']['datafrom_year'] == $i ? "selected" : "";
            $is_dt_selected = $_POST['newsletter']['datato_year'] == $i ? "selected" : "";

            $datafrom .= "<option $is_df_selected value=\"$i\">$i</option>\n";
            $datato .= "<option $is_dt_selected value=\"$i\">$i</option>\n";
        }

        $datafrom .= "</select>\n";
        $datato .= "</select>\n";


        $current_descrizione = $_POST['newsletter']['compose_newsletterdesc'];

        if ($saved_nl_id) {
            $button_delete = "<input class=\"button_in awesome\" type=\"button\" name=\"bNewsletterComposeDelete\" value=\"$b_compose_newsletter_delete\" onClick=\"if (confirm('" . $l_compose_newsletter_delete_message . "')) { document.fnewslettercomposenews.nlcomposehavetodelete.value = 1; document.fnewslettercomposenews.submit(); } \">&nbsp;&nbsp;&nbsp;";
        }
        else
            $button_delete = "";

echo <<< END

<script language="Javascript" type="text/javascript">

function checkAllNews(strTableForm, checked) {

    var frm;
    frm = document.getElementById(strTableForm);
    for(i =0 ; i< frm.length; i++) {
        if (frm[i].name.indexOf('newsletter[compose_include_page]') == 0)
            frm[i].checked = checked;
    }
}
</script>


    <form name="fnewslettercomposenews" action="$_SERVER[PHP_SELF]" method="POST">
    <input type="hidden" name="newsletter[comefrom]" value="newsletternewscompose">
    <input type="hidden" name="panel" value="newscompose">
    <input type="hidden" name="nlcomposehavetosave" value="0">
    <input type="hidden" name="nlcomposefind" value="0">
    <input type="hidden" name="nlcomposehavetodelete" value="0">
    <table class="table_border" width="
END;
    include("include/dim_all.inc.php");

echo <<< END
    " align="CENTER" cellpadding="3" cellspacing="1" border="0">
    <tr>
    <th colspan="2" class="table_tit" align="center">$l_compose_main_title</th>
    </tr>
    <tr>
    <th width="40%" class="table_tit" align="left">$l_compose_area_tematica</th>
    <td width="60% "class="table_sez" align="center">$s_aree_tematiche</td>
    </tr>

    <tr>
    <th width="40%" class="table_tit" align="left">$l_compose_newsletter_name</th>
    <td width="60% "class="table_sez" align="center">$newsletter_automatic_name</td>
    <input type="hidden" name="newsletter[compose_newslettername]" value="$newsletter_automatic_name">
    </tr>

    <tr>
    <th width="40%" class="table_tit" align="left">$l_compose_newsletter_desc</th>
    <td width="60% "class="table_sez" align="center">
    <input class="insert_area" size="70" maxlength="255" type="text" name="newsletter[compose_newsletterdesc]" value="$current_descrizione">
    </td>
    </tr>

    <tr>
    <th width="40%" class="table_tit" align="left">$l_compose_nl_load</th>
    <td width="60% "class="table_sez" align="center">$s_saved_newsletters</td>
    </tr>

    <tr>
    <th width="40%" class="table_tit" align="left">$l_select_news</th>
    <td width="60% "class="table_sez" align="center">$s_select_news</td>
    </tr>

    <tr>
    <th width="40%" class="table_tit" align="left">$l_compose_data_inizio</th>
    <td width="60% "class="table_sez" align="center">
        $l_compose_from_date:
        &nbsp;
        $datafrom
        &nbsp;
        $l_compose_to_date:
        &nbsp;
        $datato
        &nbsp;
        <input class="button_in awesome" name="bNewsletterComposeCerca" type="button" onClick="document.fnewslettercomposenews.nlcomposefind.value = 1; document.fnewslettercomposenews.submit();" value="$b_compose_news_cerca">
    </td>
    </tr>
END;


//    echo "<h1>$current_area</h1>";


    if ($current_area == 'default')
        // include anche le aree vuote
        //$s_select_area = "(`areatematica` != '' OR `areatematica` IS NOT NULL)";
        $s_select_area = "";
    else
        $s_select_area = " AND LOWER(REPLACE(REPLACE(`areatematica`, ' ', '_'), \"'\", '_')) = '" . $current_area . "'";

//= " AND REPLACE(`areatematica`, ' ', '') as arearematica = '" . $current_area_for_select . "'";

    // una pezza secca unicamente per xgio (informagiovani)
    // fino a quando son si sara' deciso sei i corsi debbano essere news

    if ($_POST['newsletter']['node_type'] == 'node_all')
        $s_select_part = "isanews = '0' OR isanews = '1' OR isanews = '2' OR isanews IS NULL";
    if ($_POST['newsletter']['node_type'] == 'node_nodes_news')
        $s_select_part = "isanews = '1' OR isanews = '2'";    
    else if ($_POST['newsletter']['node_type'] == 'node_nodes')
        $s_select_part = "isanews = '0'";
    else if ($_POST['newsletter']['node_type'] == 'node_news')
        $s_select_part = "isanews = '1'";
    else {
	$_POST['newsletter']['node_type'] = 'node_all';
        $s_select_part = "isanews = '0' OR isanews = '1' OR isanews = '2' OR isanews IS NULL";
    }

    $dbquery =
        "SELECT * FROM `node` WHERE" .
            " (`creation` >= '" .
            $_POST['newsletter']['datafrom_year'] . "-" .
            $_POST['newsletter']['datafrom_month'] . "-" .
            $_POST['newsletter']['datafrom_day'] . "'" .
            " AND `creation` <= '" . $_POST['newsletter']['datato_year'] . "-" .
            $_POST['newsletter']['datato_month'] . "-" .
            $_POST['newsletter']['datato_day'] . "') " .
            " AND (`pubblicazione` = 'pubblica' OR `pubblicazione` = 'redazionepub') AND ($s_select_part OR contenuto = 'content_xgio_corsi' OR contenuto = 'content_xgio_concorsi_borse' OR contenuto = 'content_xgio_offertelavoro' OR contenuto = 'content_xgio_segnalazioni' OR contenuto = 'content_xgio_chiamataenti')" .

            $s_select_area .
            " ORDER BY `contenuto`,`creation` ASC";


//    echo "<h1>" . $dbquery . "</h1>";


    $rowrs = $this->_nl_connh->Execute($dbquery) or
        die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());


    if (!is_array($_POST['newsletter']['compose_include_page']))
        $_POST['newsletter']['compose_include_page'] = array();

    if ($rowrs->RecordCount() > 0) {

        echo "<tr><td colspan=\"2\" class=\"table_tit\">$l_compose_elenco_news</td></tr>\n";

        while (!$rowrs->EOF) {
            
            $row = $rowrs->fields;
            $creation_date = substr($row['creation'], 8, 2) . "." . substr($row['creation'], 5, 2) . "." . substr($row['creation'], 0, 4);

            $is_checked = in_array($row['id'], $_POST['newsletter']['compose_include_page']) ? "checked" : "";

	        $s_content = str_replace("xgio_", "", substr($row['contenuto'], 8, 255));	

            if (trim($_POST['newsletter']['compose_abstract'][$row['id']]) != '')
                $current_abstract = $_POST['newsletter']['compose_abstract'][$row['id']];
            else {
                $dbquery2 = "SELECT `" . NEWSLETTER_COMPOSE_FIELD_ABSTRACT . "` FROM `" . $row['contenuto'] . "` WHERE id = '" . $row['id'] . "' LIMIT 1";
                $rowrs2 = $this->_nl_connh->Execute($dbquery2);

                if ($rowrs2 && $rowrs2->RecordCount() == 1)
                    $current_abstract = $rowrs2->fields(NEWSLETTER_COMPOSE_FIELD_ABSTRACT);
                else
                    $current_abstract = "";
            }


            // in particolari casi (xgio) occorre fare un'aggiunta:
            // ai corsi: l'ente
            // alle offerte: sede di lavoro
            // ai concorsi e borse: l'ente

            $add_xgio_text = "";

            if ($row['contenuto'] == 'content_xgio_corsi') {

                $dbquery = "SELECT `enteassociazione` FROM `" . $row['contenuto'] . "` WHERE id = '" . $row['id'] . "'";
                $rowrsadd = $this->_nl_connh->Execute($dbquery) or
                    die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());


                $add_xgio_text = " - " . str_replace("<br />", "", $rowrsadd->fields('enteassociazione'));
            }

            if ($row['contenuto'] == 'content_xgio_concorsi_borse') {

                $dbquery = "SELECT `enteassociazione` FROM `" . $row['contenuto'] . "` WHERE id = '" . $row['id'] . "'";
                $rowrsadd = $this->_nl_connh->Execute($dbquery) or
                    die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());


                $add_xgio_text = " - " . str_replace("<br />", "", $rowrsadd->fields('enteassociazione'));

            }

            if ($row['contenuto'] == 'content_xgio_offertelavoro') {

                $dbquery = "SELECT `luogodilavoro` FROM `" . $row['contenuto'] . "` WHERE id = '" . $row['id'] . "'";
                $rowrsadd = $this->_nl_connh->Execute($dbquery) or
                    die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

                $add_xgio_text = " - " . str_replace("<br />", "", $rowrsadd->fields('luogodilavoro'));

            }

            if ($add_xgio_text != "")
                $add_xgio_text = stripslashes($add_xgio_text);


            echo
            "<tr>\n" .
            "<td colspan=\"2\" class=\"table_sez\">" .
            "<input $is_checked class=\"insert_area\" type=\"checkbox\" name=\"newsletter[compose_include_page][]\" value=\"" . $row['id'] . "\">\n" .
            "&nbsp;&nbsp;" .
            "<a target=\"_blank\" href=\"../index.php?id=" . $row['id'] . "\">" .
            $rowrs->fields('sezione') .
            "</a>" .
            "&nbsp;&nbsp; [$s_content] <em>(" . $l_compose_created_on . " " . $creation_date . ")" . $add_xgio_text . "</em>" .
            "<br />" .
            "abstract: " .
            "<textarea class=\"insert_area\" cols=\"80\" name=\"newsletter[compose_abstract][$row[id]]\" type=\"textarea\" rows=\"2\" width=\"100%\">" .
            stripslashes($current_abstract) .
            "</textarea>" .
            "</td>" .
            "</tr>\n";

            $rowrs->MoveNext();
        } // while
    }

    // intestazione newsletter
    echo "<tr><td colspan=\"2\" class=\"table_tit\"><strong>$l_compose_intestazione_nl</strong></td></tr>\n";
    echo
        "<tr>" .
        "<td colspan=\"2\" class=\"table_sez\">" .
        "<textarea width=\"100%\" class=\"insert_area\" cols=\"100\" name=\"newsletter[compose_header][$current_area]\">" .
        stripslashes($_POST['newsletter']['compose_header'][$current_area]) .
        "</textarea>" .
        "</td>" .
        "</tr>";

    // piede newsletter
    echo "<tr><td colspan=\"2\" class=\"table_tit\"><strong>$l_compose_piede_nl</strong></td></tr>\n";
    echo
        "<tr>" .
        "<td colspan=\"2\" class=\"table_sez\">" .
        "<textarea width=\"100%\" class=\"insert_area\" cols=\"100\" name=\"newsletter[compose_footer][$current_area]\">" .
        stripslashes($_POST['newsletter']['compose_footer'][$current_area]) .
        "</textarea>" .
        "</td>" .
        "</tr>";

    echo
        "<tr><td colspan=\"2\" class=\"button_out\" align=\"center\">" .
        $button_delete .
        "<input onClick=\"document.fnewslettercomposenews.nlcomposehavetosave.value = 1;\" type=\"submit\" value=\"&nbsp;&nbsp;&nbsp;$b_compose_newsletter_save&nbsp;&nbsp;&nbsp;\" name=\"bNewsletterSave\" class=\"button_in awesome\">" .
        "</td></tr>";
 

echo <<< END
    </table>
    </form>
END;

    $this->_output_tomainpanel();


    } // outputComposeForm


    function outputSendingForm() {

    global $priscilla_local_path;

    $l_title_send_form = NEWSLETTER_TITLE_SENDING . " [" . "*" . " " . NEWSLETTER_REQUIRED_FIELDS . "]";


    // se e' il caso si abilita il link alla newsletter plus

    if (file_exists($priscilla_local_path . "modules/plusnl/lib/unlock_nl_plus.php"))
        $l_title_send_form .= "&nbsp;&nbsp;&nbsp;" . "<a href=\"gm.php?md=newsletter&panel=newscompose\">NEWSLETTER PLUS</a>";

    $l_recipient_list = NEWSLETTER_RECIPIENT_LIST . " " . "*";
    $l_recipient_group = NEWSLETTER_RECIPIENT_GROUP;
    $l_body_text = NEWSLETTER_EMAIL_OR_HTML_PAGE;
    $l_subject_text = NEWSLETTER_SUBJECT;
    $l_sender_text = NEWSLETTER_FROM_MAIL . " " . "*";
    $l_newsletter_resend = NEWSLETTER_NOT_TODAY_RESENDING;
    $l_newsletter_justify = NEWSLETTER_JUSTIFY;
    $l_newsletter_send_non_active = NEWSLETTER_SEND_NON_ACTIVE;
    $b_newsletter_send = NEWSLETTER_BUTTON_SEND_NEWSLETTER;
    

echo <<< END
    <form name="fnewslettersending" action="$_SERVER[PHP_SELF]" method="POST" onsubmit="return sending_warn();">
    <input type="hidden" name="newsletter[comefrom]" value="newslettersending">
    <table class="table_border" width="
END;
    include("include/dim_all.inc.php");

echo <<< END
    " align="CENTER" cellpadding="3" cellspacing="1" border="0">
    <tr>
    <th colspan="2" class="table_tit" align="CENTER">$l_title_send_form</th>
    </tr>
    <tr>
    <td width="50%" align="CENTER" class="table_sez">$l_sender_text</td>
    <td align="CENTER" class="table_sez">
    <input name="newsletter[sender]" class="insert_area" size="40" maxlength="80" style="width:90%">
    </td>
    </tr>
    <tr>
    <td width="50%" align="CENTER" class="table_sez">$l_recipient_list</td>
    <td align="CENTER" class="table_sez"><textarea name="newsletter[recipient]" class="insert_area" cols="80" rows="2" style="width:90%"></textarea></td>
    </tr>

    <tr>
    <td width="50%" align="CENTER" class="table_sez">$l_recipient_group</td>
    <td align="CENTER" class="table_sez">
END;
    $this->_output_group_list();

echo <<< END
    </td>
    <tr>
    <td colspan="2" align="LEFT" class="table_sez">
    $l_subject_text: <input class="insert_area" name="newsletter[subject]" type="TEXT" size="85" MALENGTH="80"></td>
    </tr>
    <tr>
    <td colspan="2" align="left" class="table_sez">
    $l_body_text
END;

    echo ": ";
    $this->_output_page_list();

echo <<< END
    <br />
    <textarea name="newsletter[bodytext]" class="insert_area" cols="80" rows="5" style="width:100%"></textarea>
    </td>
    </tr>

    <tr>
    <td colspan="2" align="CENTER" class="table_sez">  
    <input type="CHECKBOX" value="1" name="newsletter[justify]" class="insert_area">$l_newsletter_justify&nbsp;
    <input type="CHECKBOX" value="1" name="newsletter[sendnonactive]" class="insert_area">$l_newsletter_send_non_active&nbsp;
    <input type="CHECKBOX" value="1" name="newsletter[daynotresend]" class="insert_area">$l_newsletter_resend
    </td>
    </tr>

    <tr>
    <td colspan="2" align="CENTER" class="button_out">  
    <input type="SUBMIT" value="&nbsp;&nbsp;&nbsp;$b_newsletter_send&nbsp;&nbsp;&nbsp;" name="bNewsletterSend" class="button_in awesome">
    </td>
    </tr>
    </table>
    </form>
END;


    } // outputSendForm



    function outputNewsletterGroup () {

    
    $l_title_mailgroup_form = NEWSLETTER_TITLE_NEWSLETTER_LIST;
    $m_no_newsletter_found = NEWSLETTER_MSG_NO_NEWSLETTER;
    $l_newsletter_id = NEWSLETTER_ID;
    $l_newsletter_subscriptions = NEWSLETTER_N_SUBSCRIPTIONS;
    $l_newsletter_user = NEWSLETTER_OWNER;
    $l_newsletter_name = NEWSLETTER_NAME;
    $l_newsletter_description = NEWSLETTER_DESCRIPTION;
    $l_newsletter_azioni = NEWSLETTER_ACTIONS;
    $l_newsletter_modifica = NEWSLETTER_EDIT;
    $l_newsletter_elimina = NEWSLETTER_DELETE;
    $l_newsletter_frommail = NEWSLETTER_FROM_MAIL;
    $l_newsletter_timelastsent = NEWSLETTER_LAST_SENT;


echo <<< END
        <form name="fmailgroup" action="$_SERVER[PHP_SELF]" method="POST">
    <input type="hidden" name="newsletter[comefrom]" value="mailgroup">
        <table class="table_border" width="
END;
        include("include/dim_all.inc.php");

echo <<< END
        " align="CENTER" cellpadding="3" cellspacing="1" border="0">
        <tr>
        <th colspan="9" class="table_tit" align="CENTER">$l_title_mailgroup_form</th>
        </tr>
END;

        if ($this->_nl_user != 'superuser')
            $add_query = " WHERE user = '" . $this->_nl_user . "'";
    
    // stampa dell'elenco delle newsletter
    $dbquery = "SELECT COUNT(" . NEWSLETTER_TABLE_MAILDATA . ".id) AS nmail, " .
    "gid, name, description, user, frommail, nl_lastsent" .
    " FROM " .
    NEWSLETTER_TABLE_MAILGROUP . " LEFT JOIN " . NEWSLETTER_TABLE_MAILDATA . " ON idmailg = gid " . $add_query .
    " GROUP BY gid DESC";



        $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

        if ($rowrs->RecordCount() <= 0) {
        echo "</table>\n</form>\n"; 
        $this->_output_message($m_no_newsletter_found);
        return;
        } else {

echo <<< END
        <tr>
    <td width="5%" align="CENTER" class="table_tit">$l_newsletter_id</td>
    <td nowrap="nowrap" width="5%" align="CENTER" class="table_tit">$l_newsletter_subscriptions</td>
    <td nowrap="nowrap" align="CENTER" class="table_tit">$l_newsletter_user</td>
    <td nowrap="nowrap" align="CENTER" class="table_tit">$l_newsletter_name</td>
        <td align="CENTER" class="table_tit">$l_newsletter_description</td>
    <td nowrap="nowrap" align="CENTER" class="table_tit">$l_newsletter_frommail</td>
    <td nowrap="nowrap" align="CENTER" class="table_tit">$l_newsletter_timelastsent</td>
    <td colspan="2" class="table_tit" align="CENTER">$l_newsletter_azioni</td>
        </tr>
END;

            while (!$rowrs->EOF) {
                $row = $rowrs->fields;

        $ultimo_invio = $row['nl_lastsent'] ? date("d-m-Y", $row['nl_lastsent']) : " --- ";
echo <<< END
        <tr>
        <td align="CENTER" class="table_id"><a href="javascript:nle($row[gid], 's');">$row[gid]</a></td>
        <td align="CENTER" class="table_id">$row[nmail]</td>
        <td align="CENTER" class="table_sez">$row[user]</td>
        <td align="CENTER" class="table_sez">$row[name]</td>
        <td align="CENTER" class="table_sez">$row[description]</td>
        <td align="CENTER" class="table_sez">$row[frommail]</td>
        <td align="CENTER" class="table_sez">$ultimo_invio</td>
        <td width="10%" align="CENTER" class="table_sez"><a href="javascript:nle($row[gid],'m');">$l_newsletter_modifica</a></td>
        <td width="10%" align="CENTER" class="table_sez"><a href="javascript:nle($row[gid],'d');">$l_newsletter_elimina</td>
        </tr>
END;
                $rowrs->MoveNext();
            } // while
        }

echo <<< END
    </table>
    </form>
END;

    } // outputMailGroup


    function outputNewsletterCreate($id, $action) {



    // modifica di una newsletter preesistente
    if ($action == 'm') {
        $l_title_newslettercreate_form = NEWSLETTER_EDIT_NEWSLETTER_CONFIG;
        $b_newsletter_create = NEWSLETTER_BUTTON_SAVE_CONFIG;
        $hidden_nl_action = "<input type=\"HIDDEN\" name=\"newsletter[newsletter_id]\" value=\"$id\">\n";
        
        // si vanno a prendere le impostazioni di questa nl
        $dbquery = "SELECT * FROM " . NEWSLETTER_TABLE_MAILGROUP . " WHERE gid = '$id'";
        $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

        if ($rowrs->RecordCount() > 0) {
            $row = $rowrs->fields;
            $nlname = $row['name'];
            $nldescription = $row['description'];
            $nlfrommail = $row['frommail'];
            $nlowner = $row['user'];
            $nltemplate = $row['template'];
            $nlunsubscribemsg = $row['unsubscribemsg'];
            $nltagpageid = $row['tagpageid'];
            $nlsendingtemplate = $row['sending_template'];

            if ($this->_nl_user == 'superuser') {
                $newsletter_owner_stuff  = NEWSLETTER_OWNER . ": ";
                $newsletter_owner_stuff .=  $this->_output_tenda_owner($nlowner);
                $newsletter_owner_stuff .= "&nbsp;&nbsp;";
            }
            else $newsletter_owner_stuff = '';

        } else {
            $this->_nl_error = true;
            $this->_nl_last_error = NEWSLETTER_MSG_NO_NEWSLETTER . " ID =" . " " . $id;
            $this->outError();
            return;
        }
    // creazione di una nuova newsletter
    } else {
        $l_title_newslettercreate_form = NEWSLETTER_TITLE_NEW_NEWSLETTER_CREATE;
        $b_newsletter_create = $l_title_newslettercreate_form;
        $hidden_nl_action = '';

        $nlname = '';
        $nldescription = '';
        $nlfrommail = '';
        $nltemplate = '';
        $nlunsubscribemsg = '';
        $nltagpageid = '';
        $nlsendingtemplate = '';
    }
    

    $l_newsletter_name = NEWSLETTER_NAME;
    $l_newsletter_description = NEWSLETTER_DESCRIPTION;
    $l_newsletter_frommail = NEWSLETTER_FROM_MAIL;
    $l_newsletter_template = NEWSLETTER_TEMPLATE_NOTE;
    $l_newsletter_unsubscribe = NEWSLETTER_UNSUBSCRIBE_NOTE;
    $l_newsletter_unsubscribe_page = NEWSLETTER_UNSUBSCRIBE_PAGE;
    $l_newsletter_sending_template = NEWSLETTER_SENDING_TEMPLATE;

echo <<< END
        <form name="fmailnlcreate" action="$_SERVER[PHP_SELF]" method="POST">$hidden_nl_action
    <input type="hidden" name="newsletter[comefrom]" value="newslettercreate">
        <table class="table_border" width="
END;
        include("include/dim_all.inc.php");

echo <<< END
        " align="CENTER" cellpadding="3" cellspacing="1" border="0">
        <tr>
        <th colspan="3" class="table_tit" align="CENTER">$l_title_newslettercreate_form</th>
        </tr>
    <tr>
    <td width="25%" align="CENTER" class="table_sez">$l_newsletter_name:<br /><input class="insert_area" type="text" style="width:90%" name="newsletter[nlname]" value="$nlname"></td>
    <td width="40%" align="CENTER" class="table_sez">$l_newsletter_description:<br /><input class="insert_area" type="TEXT" style="width:90%" name="newsletter[nldescription]" value="$nldescription"></td>
    <td  width="35%" align="CENTER" class="table_sez">$l_newsletter_frommail:<br /><input class="insert_area" type="TEXT" style="width:90%" name="newsletter[nlfrommail]" value="$nlfrommail"></td>
    </tr>
    <tr>
    <td width="25%" align="CENTER" class="table_sez">$l_newsletter_template</td>
    <td width="40%" align="CENTER" class="table_sez">
<textarea rows="3"; style="width:95%" class="insert_area"  name="newsletter[nltemplate]">$nltemplate</textarea>
    </td>
    <td width="35%" align="CENTER" class="table_sez">$l_newsletter_sending_template:<br />
END;

    $this->_output_template_list("newsletter[nlsendingtemplate]", $nlsendingtemplate);

echo <<< END
    </td>
    </tr>
    <tr>
    <td width="25%" align="CENTER" class="table_sez">$l_newsletter_unsubscribe</td>
    <td width="40%" align="CENTER" class="table_sez">
<textarea rows="6"; style="width:95%" class="insert_area"  name="newsletter[nlunsubscribemsg]">$nlunsubscribemsg</textarea>
    </td>
    <td  width="35%" align="CENTER" class="table_sez">$l_newsletter_unsubscribe_page:<br />
END;

    $this->_output_page_list("newsletter[nltagpageid]", $nltagpageid);

echo <<< END
    </td>

    </tr>
    <tr>
    <td colspan="3" align="CENTER" class="button_out">
    $newsletter_owner_stuff
    <input type="SUBMIT" class="button_in awesome" name="bMailgroup" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$b_newsletter_create&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"></td>
    </tr>

    </table>
    </form>
END;

    } // outputNewsletterCreate


    function outputNewsletterInfo ($nl, $gid, $neworderby) {


    $l_title_newsletter_info = NEWSLETTER_TITLE_SUBSCRIPTIONS_LIST;
    $l_title_newsletter_insert = NEWSLETTER_TITLE_NEW_EMAIL_INSERT;
    $l_email = NEWSLETTER_EMAIL;
    $l_email_file = NEWSLETTER_FILE;
    $b_mail_insert = NEWSLETTER_BUTTON_INSERT;
    $b_mail_import = NEWSLETTER_BUTTON_IMPORT_MAIL_LIST;
    $b_set_activestatus_on = NEWSLETTER_BUTTON_ACTIVE_SELECTED;
    $b_set_activestatus_off = NEWSLETTER_BUTTON_DEACTIVATE_SELECTED;
    $b_email_delete = NEWSLETTER_BUTTON_REMOVE_SELECTED;


    // alla ricerca del nome della newsletter
    $dbquery = "SELECT name FROM " . NEWSLETTER_TABLE_MAILGROUP . " WHERE gid = '$gid'";
        $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
    if ($rowrs->RecordCount() <= 0) {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_ACCESS_NOT_PERMITTED . " " . $gid;
        $this->outError();
        return;
    }
    else $newsletter_name = $rowrs->fields('name');

    if (trim($nl['yesnoselect']) != "" && $nl['yesnoselect'] != "__all__")
        $s_filter = " AND `isactivestatus` = '" . $nl['yesnoselect'] . "'";
    else
        $s_filter = ""; 

    // contiamo quante email ci sono

    $dbquery = "SELECT COUNT(id) AS item_total FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE idmailg = '$gid'" . $s_filter;
    $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
    $item_total = $rowrs->fields('item_total');


    $search_status = false;

    // siamo in modalita' ricerca?
    if (isset($nl['searchemail']) && isset($nl['bSearchEmail'])) {
        $search_status = true;
        
        // si resetta la navigazione
        $nl['showlimit'] = 0;
        $nl['position'] = 0;

  
        $search_where_clause = " AND idmailg = '$gid'";
        $is_a_global_search = false;
 
        $dbquery_search =
        "SELECT id, email, isactivestatus, time_activation, time_lastsent, nmailsent, nmailfailed" .
        " FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE LOWER(email) LIKE '%" . $nl['searchemail'] . "%'";

        if (!$is_a_global_search)
            $dbquery_search .= $search_where_clause;

        $rowrs_search = $this->_nl_connh->Execute($dbquery_search) or die("ERROR: $dbquery_search<br />" . $this->_nl_connh->ErrorMsg());

    } // 

    // vediamo quante sono attive (se non siamo in modalita' ricerca
    if ($item_total && !$search_status) {
        $dbquery =
        "SELECT COUNT(id) AS item_total_active FROM " .
        NEWSLETTER_TABLE_MAILDATA . " WHERE idmailg = '$gid' AND isactivestatus = 'yes'";

        $rowrs = $this->_nl_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
        $item_total_active = $rowrs->fields('item_total_active');

        $s_item_total = "[" . NEWSLETTER_EMAIL_ACTIVATED . " " . $item_total_active . " / " . $item_total . "]";
    }
    else $s_item_total;


    // eventuali spostamenti
    if (!isset($nl['showlimit'])) {
         $nl["showlimit"] = 50;
        $nl["position"] = 0;
    }

    // eventuali spostamenti

    if ($nl['showlimit']) {
        $position_mod = ($item_total % $nl['showlimit']);
        $position_max = $item_total - $position_mod;
    
        if (!$position_mod)
        $position_max -= $nl['showlimit'];

        if (isset($nl['navigation_init']))
        $nl['position'] = 0; 
        else if (isset($nl['navigation_forward']))
         $nl['position'] += $nl['showlimit'];   
        else if (isset($nl['navigation_rewind']))
         $nl['position'] -= $nl['showlimit'];   
        else if (isset($nl['navigation_end']))
        $nl['position'] = $position_max;

        // aggiustamenti
        if ($nl['position'] < 0)
        $nl['position'] = 0;

        if ($nl['position'] > $position_max)
        $nl['position'] = $position_max;
    }


    if ($nl['showlimit'] && $item_total > $nl['showlimit']) {
        $navigation_panel_s =
        $this->_build_navigation_panel($nl['position'], $position_max, $item_total, $nl['showlimit']);
        $query_limit = " LIMIT $nl[position], $nl[showlimit]";    
    } else {
        $navigation_panel_s = '';
        $query_limit = '';
    }


    
    // eventuali default da settare

    if (!isset($nl['orderby']) || trim($nl['orderby']) == '')
        $nl['orderby'] = 'id';

        if (!isset($nl['orderversus']) || trim($nl['orderversus']) == '')
            $nl['orderversus'] = "DESC";

    if (!isset($nl['position']))
        $nl['position'] = 0;


    // calcolo dell'order versus
    if (trim($neworderby) != '') {
        if ($neworderby != $nl['orderby']) {
        $nl['orderby'] = $neworderby;
        $nl['orderversus'] = "ASC";
        } else {
        if ($nl['orderversus'] == "DESC")
            $nl['orderversus'] = "ASC";
        else $nl['orderversus'] = "DESC";
        }
    }

    if (!$search_status) {

        $query_order = " ORDER BY " . $nl['orderby'] . " " . $nl['orderversus'];
        $query_body =
        "SELECT id, email, isactivestatus, time_activation, time_lastsent, nmailsent, nmailfailed" .
        " FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE idmailg = '$gid' " . $s_filter;

        $dbquery = $query_body . $query_order . $query_limit;
        $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
        
        $l_table_testa = "$l_title_newsletter_info \"$newsletter_name\" [" .
        NEWSLETTER_MSG_ORDER_SETTING_HELP . "]";

    }
    else { 
        $rowrs = $rowrs_search;
        $l_table_testa = NEWSLETTER_SEARCH_FOR . " \"" . $nl['searchemail'] . "\". " . NEWSLETTER_RESULTS . ": " . $rowrs->RecordCount() . "."; 
    }


    // codice javascript per selezionare tutte le email

echo <<< END
<script language="Javascript" type="text/javascript">
function checkAll(fname) {
var nb;
var chk;
    with (fname) {
        chk = checkallstatus.checked;
        nb = elements.length;
        for (var i = 0; i< nb; i++) {
            var e = elements[i];
            if (e.type == "checkbox" && e.name != "checkallstatus")
                e.checked = chk;
            } // for
        } // with
    } // checkAll
</script>
<noscript>err_js_not_supported</noscript>
</head>
END;

echo <<< END
        <form name="fnewsletterinfo" action="$_SERVER[PHP_SELF]" method="POST">
    <input type="hidden" name="max_file_size" value="2097152" />
        <input type="HIDDEN" name="newsletter[comefrom]" value="newsletterinfo">
    <input type="HIDDEN" name="newsletter[position]" value="$nl[position]">
    <input type="HIDDEN" name="fnlid" value="$gid">
    <input type="hidden" name="fnledit" value="s" />
    <input type="hidden" name="neworderby" />
    <input type="HIDDEN" name="newsletter[orderby]" value="$nl[orderby]">
    <input type="HIDDEN" name="newsletter[orderversus]" value="$nl[orderversus]">
        <table class="table_border" width="
END;
        include("include/dim_all.inc.php");

echo <<< END
        " align="CENTER" cellpadding="3" cellspacing="1" border="0">
        <tr>
        <th colspan="2" class="table_tit" align="CENTER">$l_title_newsletter_insert "$newsletter_name" $s_item_total</th>
        </tr>
    <tr>
    <td width="50%" align="CENTER" class="table_sez">$l_email: <input class="insert_area" name="newsletter[newmail]" type="TEXT" style="width:80%"></td>
    <td width="50%" align="CENTER" class="table_sez">$l_email_file: <input class="insert_area" name="upfile" type="file" size="40" /></td>
    </tr>
    <tr>
    <td align="CENTER" class="button_out"><input class="button_in awesome" type="SUBMIT" name="newsletter[bEmailInsert]" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$b_mail_insert&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"></td>
    <td align="CENTER" class="button_out"><input class="button_in awesome" type="SUBMIT" onclick="document.forms.fnewsletterinfo.enctype = 'multipart/form-data';" name="newsletter[bEmailImport]" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$b_mail_import&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"></td>
    </tr>
    </table>
    <br />
        <table class="table_border" width="
END;
        include("include/dim_all.inc.php");

echo <<< END
        " align="CENTER" cellpadding="3" cellspacing="1" border="0">
        <tr>
        <th colspan="8" class="table_tit" align="CENTER">$l_table_testa</th>
        </tr>
END;




    echo
        "<tr>" .
        "<td colspan=\"2\" class=\"table_tit\" align=\"CENTER\">" .
        "<a href=\"../modules/newsletter/lib/dn.php?gid=$gid\">" . NEWSLETTER_EXPORT_MAIL_LIST . "</a>" .
        "</td>" .
        "<td colspan=\"6\" class=\"table_tit\" align=\"RIGHT\">" .
        "<input type=\"TEXT\" name=\"newsletter[searchemail]\" class=\"insert_area\" size=\"20\">" . "&nbsp;" .
        "<input type=\"SUBMIT\" name=\"newsletter[bSearchEmail]\"  class=\"button_in awesome\" value=\"" . NEWSLETTER_BUTTON_EMAIL_FINDER . "\">\n" .
        "&nbsp;&nbsp;" .
	NEWSLETTER_YESNO_SELECT . "&nbsp;";

	$this->_output_yesno_select($nl['yesnoselect']);

    echo
	"&nbsp;&nbsp;" .
        NEWSLETTER_EMAIL_PER_PAGE . ": ";

    $this->_output_showlimit_selection($nl['showlimit']);
    if ($navigation_panel_s != '')
        echo "&nbsp;" . $navigation_panel_s;
    echo "</td>\n</tr>\n";


if ($rowrs->RecordCount() > 0) {

    // stampa delle intestazioni
    echo
        "<tr>\n" .
        "<td align=\"CENTER\" class=\"table_tit\"><a href=\"javascript:order('id');\">" . NEWSLETTER_ID . "</a></td>\n" .
        "<td align=\"CENTER\" class=\"table_tit\"><a href=\"javascript:order('email');\">" . NEWSLETTER_EMAIL . "</a></td>\n" .
        "<td align=\"CENTER\" class=\"table_tit\"><a href=\"javascript:order('isactivestatus');\">" . NEWSLETTER_EMAIL_STATUS . "</a></td>\n" .
        "<td align=\"CENTER\" class=\"table_tit\"><a href=\"javascript:order('time_activation');\">" . NEWSLETTER_SUBSCRIPTION_TIME . "</a></td>\n" .
        "<td align=\"CENTER\" class=\"table_tit\"><a href=\"javascript:order('time_lastsent');\">" . NEWSLETTER_LAST_SENT . "</a></td>\n" .
        "<td align=\"CENTER\" class=\"table_tit\"><a href=\"javascript:order('nmailsent');\">" . NEWSLETTER_EMAIL_SENT . "</a></td>\n" .
        "<td align=\"CENTER\" class=\"table_tit\"><a href=\"javascript:order('nmailfailed');\">" . NEWSLETTER_EMAIL_FAILED . "</a></td>\n" .
        "<td align=\"CENTER\" class=\"table_tit\">" .
        NEWSLETTER_ACTION_SELECT .
        "&nbsp;" . NEWSLETTER_SELECT_ALL . "<input onclick=\"checkAll(document.forms.fnewsletterinfo);\" class=\"insert_area\" name=\"checkallstatus\" type=\"CHECKBOX\">" .
        "</td>\n" .
        "</tr>\n";


    while (!$rowrs->EOF) {

        $row = $rowrs->fields;

        $s_confermato = $row['isactivestatus'] == 'yes' ? NEWSLETTER_YES : NEWSLETTER_NO;
        $s_registrazione = $row['time_activation'] ? date("d-m-Y", $row['time_activation']) : " --- ";
        $s_ultimoinvio = $row['time_lastsent'] ? date("d-m-Y", $row['time_lastsent']) : " --- ";
        $s_selected = "<input name=\"newsletter[maillist][]\" class=\"insert_area\" type=\"CHECKBOX\" value=\"$row[id]\">";
        
        echo
        "<tr>\n" .
        "<td align=\"CENTER\" class=\"table_sez\">" . $row['id'] . "</td>\n" .
        "<td align=\"CENTER\" class=\"table_sez\">" . $row['email'] . "</td>\n" .   
        "<td align=\"CENTER\" class=\"table_sez\">" . $s_confermato . "</td>\n" .
        "<td align=\"CENTER\" class=\"table_sez\">" . $s_registrazione . "</td>\n" .
        "<td align=\"CENTER\" class=\"table_sez\">" . $s_ultimoinvio . "</td>\n" .
        "<td align=\"CENTER\" class=\"table_sez\">" . $row['nmailsent'] . "</td>\n" .
        "<td align=\"CENTER\" class=\"table_sez\">" . $row['nmailfailed'] . "</td>\n" .
        "<td align=\"CENTER\" class=\"table_sez\">" . $s_selected . "</td>\n" .
        "</tr>\n";

        $rowrs->MoveNext();

    } // while

echo <<< END
    <tr>
    <td colspan="8" align="CENTER" class="button_out">
    <input class="button_in" type="SUBMIT" name="newsletter[bSetActiveStatusOn]" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$b_set_activestatus_on&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;">
    &nbsp;&nbsp;
    <input class="button_in" type="SUBMIT" name="newsletter[bSetActiveStatusOff]" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$b_set_activestatus_off&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;">
    &nbsp;&nbsp;
    <input class="button_in" type="SUBMIT" name="newsletter[bEmailDelete]" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$b_email_delete&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;">
    </td>
    </tr>
END;
}

    echo "</table></form>\n";


    $this->_output_tomainpanel();

    } // outputNewsletterInfo


    function handleNewsletterComposeSave ($nl) {


        $newsletternewslist = base64_encode(bzcompress(serialize($nl['compose_include_page'])));
        $newsletterabstracts = base64_encode(bzcompress(serialize($nl['compose_abstract'])));

        $newsletterdatestart = $nl['datafrom_year'] . "-" . $nl['datafrom_month'] . "-" . $nl['datafrom_day'];
        $newsletterdateend = $nl['datato_year'] . "-" . $nl['datato_month'] . "-" . $nl['datato_day'];

 
        if (is_numeric($nl['compose_savednl']) && $nl['compose_savednl'])
            $saved_nl_id = $nl['compose_savednl'];
        else
            $saved_nl_id = 0;

/*
            echo "<pre>";
            print_r($nl);
            echo "</pre>";
            echo "</h1>";
*/

        if (!$saved_nl_id) {

            // si verifica che non esista gia' una newsletter con questo nome
            $dbquery = "SELECT id FROM `newsletter_compose_saved` WHERE `user` = '" . $this->_nl_user . "' AND newslettername = '" . $nl['compose_newslettername'] . "'";

            $rowrsoldnl = $this->_nl_connh->Execute($dbquery) or
                die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

            if ($rowrsoldnl->RecordCount()) {
                $this->_output_message(NEWSLETTER_COMPOSE_NEWSLETTER_EXISTS . " ( " . $nl['compose_newslettername'] . ", ID = " . $rowrsoldnl->fields('id') . ")");
                return;
            }



            $dbquery = "INSERT INTO `newsletter_compose_saved` (`newslettername`, `newsletterarea`, `newsletternewslist`, `newsletterheader`, `newsletterfooter`, `newsletterdesc`, `newsletterabstracts`, `newsletterdatestart`, `newsletterdateend`, `user`) VALUES (".
            "'" . $nl['compose_newslettername'] . "', " .
            "'" . $nl['compose_areatematica'] . "', " .
            "'" . $newsletternewslist . "', " .
            "'" . $nl['compose_header'][$nl['compose_areatematica']] . "', " .
            "'" . $nl['compose_footer'][$nl['compose_areatematica']] . "', " .
            "'" . $nl['compose_newsletterdesc'] . "', " .
            "'" . $newsletterabstracts . "', " .
            "'" . $newsletterdatestart . "', " .
            "'" . $newsletterdateend . "', " .
            "'" . $this->_nl_user . "'" .
            ")";

        }
        else {

            if ($this->_nl_user != 'superuser')
                $add_query = " AND user = '$this->_nl_user'";
            else
                $add_query = '';

            $dbquery = "UPDATE `newsletter_compose_saved` SET " .
                "`newsletterarea` = '" . $nl['compose_areatematica'] . "', " .
                "`newsletternewslist` = '" . $newsletternewslist . "', " .
                "`newsletterheader` = '" . $nl['compose_header'][$nl['compose_areatematica']] . "', " .
                "`newsletterfooter` = '" . $nl['compose_footer'][$nl['compose_areatematica']] . "', " .
                "`newsletterdesc` = '" . $nl['compose_newsletterdesc'] . "', " .
                "`newsletterabstracts` = '" . $newsletterabstracts . "', " .
                "`newsletterdatestart` = '" . $newsletterdatestart . "', " .
                "`newsletterdateend` = '" . $newsletterdateend . "' " .
                "WHERE id = '" . $saved_nl_id . "' " . $add_query;
        }


        $this->_nl_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

        if (!$saved_nl_id)
            $saved_nl_id = $this->_nl_connh->Insert_ID();

        $this->_output_message(NEWSLETTER_COMPOSE_SAVED . " (ID = " . $saved_nl_id  . ")");

    } // handleNewsletterComposeSave

    function handleNewsletterComposeDelete ($nl) {

        if ($this->_nl_user != 'superuser')
            $add_query_part = " WHERE user = '$this->_nl_user'";
        else
            $add_query_part = '';

        $dbquery = "DELETE FROM `newsletter_compose_saved` WHERE id = '" . $nl['compose_savednl'] . "' LIMIT 1";
        $this->_nl_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

        if ($this->_nl_connh->Affected_Rows() == 1) {
            unset($_POST['newsletter']['compose_savednl']);
            $this->_output_message(NEWSLETTER_COMPOSE_DELETED . " (" . $nl['compose_newslettername'] . ")");
        }

    } // handleNewsletterComposeDelete


    function handleNewsletterEmailManager ($nl, $gid) {


    $lista_id = $nl[maillist];

    // costruzione clausola where
    $where_clause = '';
    $dbquery = '';

    foreach ($lista_id as $id) {
        if (is_numeric($id)) {
        if ($where_clause == '')
            $where_clause = " WHERE idmailg = '$gid' AND (id = '$id'";
        else
            $where_clause .= " OR id = '$id'";
        }
    }

    if ($where_clause != '') {
        $where_clause .= ")";

        // disattivazione email
        if (isset($nl['bSetActiveStatusOff']))
        $dbquery = "UPDATE " . NEWSLETTER_TABLE_MAILDATA . " SET isactivestatus = 'no'";

        // attivazione email
        else if (isset($nl['bSetActiveStatusOn'])) 
        $dbquery =  "UPDATE " . NEWSLETTER_TABLE_MAILDATA . " SET isactivestatus = 'yes'";

        // rimozione
        else if (isset($nl['bEmailDelete']))
        $dbquery = "DELETE FROM " . NEWSLETTER_TABLE_MAILDATA;
        
        // e si esegue la query
        if ($dbquery != '') {
        $dbquery .= $where_clause;

        $this->_nl_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
        } // $dbquery != ''

    } // if ($where_clause != ''

    } // handleNewsletterEmailManager


    function handleNewsletterEmailInsert ($nl, $gid) {

    $email = trim($nl['newmail']);

    if ($email == "" && trim($nl['searchemail']) != "") {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_MSG_USE_SEARCH_BUTTON;
        return;
    }

    // verifico la bonta' dell'indirizzo email
    if(!ereg("^[^@ ]+@[^@ ]+.[a-zA-Z]{2,4}$", $email)) {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_MSG_EMAIL_INVALID . ": " . "\"$email\"";
        return;
    }
    
    if ($this->_mail_exists_in_list ($gid, $email)) {
        $this->_nl_error = true;
            $this->_nl_last_error = NEWSLETTER_MSG_EMAIL_DOUBLE . ": " . "\"$email\"";
            return;
    }

    // finalmente si inserisce

    $adesso = time();
    $dbquery = "INSERT INTO " . NEWSLETTER_TABLE_MAILDATA . " (idmailg, email, isactivestatus, time_activation) VALUES ('$gid', '$email', 'yes', '$adesso')";
    $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
    
    } // handleNewsletterEmailInsert



    // importazione di indirizzi email da file testuale

    function handleNewsletterEmailImport ($nl, $gid) {

    $filename = $_FILES["upfile"]["name"];

    if (trim($filename) == '') {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_MSG_IMPORT_FILENAME_MISSING;
        return;
    }

    if (@is_uploaded_file($_FILES["upfile"]["tmp_name"])) {
        
//      if (strtolower($_FILES["upfile"]["type"]) == "text/plain") {
//      tolto il controllo perche' mozilla ad esempio buttava su il file come octet-stream
//
        if (true) {
        // si processa il file uploadato
        $importfile = file($_FILES["upfile"]["tmp_name"]);

        $mail_error = array();
        $nmail_insert = 0;

        foreach ($importfile as $cmail) {
       
            $cmail = trim($cmail);

            if ($cmail == '' || strlen($cmail) > 254)
            continue;
 
            if(!ereg("^[^@ ]+@[^@ ]+.[a-zA-Z]{2,4}$", $cmail)) {
            $mail_error[] = $cmail;
            continue;
            }
            
            // vediamo se per caso questa email e' gia' in lista
            if ($this->_mail_exists_in_list ($gid, $cmail))
            $mail_error[] = $cmail;
            else {
            // inserimento di un nuovo indirizzo
            $adesso = time();
            $dbquery =
                "INSERT INTO " .
                NEWSLETTER_TABLE_MAILDATA .
                " (idmailg, email, isactivestatus, time_activation) VALUES ('$gid', '$cmail', 'yes', '$adesso')";
            $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
            $nmail_insert++;
            }
        } // foreach

        if (count($mail_error))
                $mail_error = array_unique($mail_error);

        // si stampano le conclusioni
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_MSG_N_EMAIL_IMPORTED . ": " . $nmail_insert;

        $nmail_error = count($mail_error);

        if ($nmail_error) {
            echo
            "<table cellpadding=\"3\" cellspacing=\"1\" align=\"CENTER\" width=\"50%\">\n" .
            "<tr><th class=\"table_tit\">" .
            NEWSLETTER_MSG_EMAIL_NOT_IMPORTED .
            "</th></tr>" .
            "<tr><td align=\"CENTER\" class=\"table_sez\">\n" .
            "<textarea READONLY class=\"insert_area\" rows=\"3\" style=\"width:90%\">\n";

            $s_failed = '';
            foreach ($mail_error as $fmail) {
            if ($s_failed == '')
                $s_failed = $fmail;
            else
                $s_failed .= ", " . $fmail;
            }
            echo $s_failed . "</textarea>\n</td></tr></table>\n";
        } // if ($nmail_error

        } else {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_MSG_MIMETYPE_ERROR . " \"" . $_FILES["upfile"]["type"] . "\"";
        return;
        }


        // eventuale rimozione del file temporaneo
        @unlink($_FILES["upfile"]["tmp_name"]);
    }
    else {
        $this->nl_error = true;
        $this->nl_last_error = NEWSLETTER_MSG_UPLOADING_ERROR . " \"" . $_FILES["upfile"]["name"] . "\"";
        return;
    }

    } // handleNewsletterEmailImpor


    function handleNewsletterCreate($nl) {


    if (trim($nl[nlname]) == '' || trim($nl[nlfrommail]) == '') {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_ERROR_NAME_OR_FROMMAIL;
        return;
    }


    // se esite un id si fa un update 
    if (isset($nl['newsletter_id']) && is_numeric($nl['newsletter_id'])) {
        // superuser puo modificare il proprietario di una newsletter
        if ($this->_nl_user == 'superuser')
        $owner_part = "user = '" . $nl['owner'] . "', ";
        else
        $owner_part = '';

        $dbquery = "UPDATE " . NEWSLETTER_TABLE_MAILGROUP . " SET $owner_part name = '$nl[nlname]', description = '$nl[nldescription]', frommail = '$nl[nlfrommail]', template = '$nl[nltemplate]', unsubscribemsg = '$nl[nlunsubscribemsg]', tagpageid = '$nl[nltagpageid]', sending_template = '$nl[nlsendingtemplate]' WHERE gid = '$nl[newsletter_id]'"; 
    }
    else {
        $dbquery = "INSERT INTO " . NEWSLETTER_TABLE_MAILGROUP .
        " (name, description, user, frommail, template, unsubscribemsg, tagpageid, sending_template) VALUES ('$nl[nlname]', '$nl[nldescription]', '$this->_nl_user', '$nl[nlfrommail]', '$nl[nltemplate]', '$nl[nlunsubscribemsg]', '$nl[nltagpageid]', '$nl[nlsendingtemplate]')";

    }

    $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());


    } // handleNewsletterCreate


    function handleNewsletterRemove ($id, $action) {

        $dbquery = "DELETE FROM " . NEWSLETTER_TABLE_MAILGROUP . " WHERE gid = '$id'";
        $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

        // eliminazione di tutti gli iscritti a questa newsletter

        $dbquery = "DELETE FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE idmailg = '$id'";
        $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

        $_nl_error = true;
        $_nl_last_error =
            NEWSLETTER_MSG_NEWSLETTER_DELETED . " " . $id .
            " -- " . NEWSLETTER_MSG_SUBSCRIPTIONS_DELETED . ": " . $this->_nl_connh->Affected_Rows();

    } // handleNewsletterRemove


    function handleNewsletterSending ($nl, $smtpconf) {

    $debug = false;
    global $priscilla_local_path;

    require "../modules/newsletter/lib/mail_engine_class.php";
    $have_to_include_unsubscribe = false;

    if ($nl['fromsitepage'])
        $return_link = "../index.php?id=" . $nl['pageid'];
    else
        $return_link = '';

    if ($nl['pageid'] == -1)
        $is_html_mail = false;
    else $is_html_mail = true;

    // un controllo sull'oggetto
    if (trim($nl['subject']) == '') {
        $this->_nl_last_error = NEWSLETTER_MSG_SUBJECT_MISSING;
        $this->_nl_error = true;
        $this->outError();
        $this->_output_tomainpanel($return_link);
        return;
    }
    else $subject = stripslashes($nl['subject']);

    // calcolo stimato della basedir di questo server
    $server_basedir = $_SERVER['SERVER_NAME'] . dirname(dirname($_SERVER['PHP_SELF']));
    if ($server_basedir{strlen($server_basedir) - 1} == '/')
    $server_basedir = substr($server_basedir, 0, -1);

    // email di tipo testo
    if (! $is_html_mail) {
        if (trim($nl['bodytext']) == '') {
            $this->_nl_last_error = NEWSLETTER_MSG_EMAIL_TEXT_EMPTY;
            $this->_nl_error = true;
            $this->outError();
            $this->_output_tomainpanel($return_link);
            return;
        }
        else $pagesource = stripslashes($nl['bodytext']);
        
        // giustificazione
        if ($nl['justify'])
            $pagesource = $this->_wraplines($pagesource, NEWSLETTER_DEFAULT_MAIL_WIDTH);

    }
    // altrimenti si invia una email di tipo html
    else {
        $CHUNK = 4096;
        $pageid = $nl['pageid'];
        $pagetocall = "http://" . $server_basedir . "/index.php?id=" . $pageid;

        // se si sta spedendo una newsletter andiamo a settare l'eventuale template
        if ($nl['recipient_group'] != -1) {
            $sending_template = '';
            $dbquery = "SELECT sending_template FROM " . NEWSLETTER_TABLE_MAILGROUP . " WHERE gid = '$nl[recipient_group]'";
            $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

            if ($rowrs->RecordCount())
                $sending_template = $rowrs->fields('sending_template');

            // costruzione della newsletter con eventuale template personalizzato
            if (trim($sending_template) != '') {
                // se il template non c'e' oppure e' vuoto o non e' leggibile si restitusice un errore
                $template_file = $priscilla_local_path . "templates/" . $sending_template;

                if (!file_exists($template_file) || !is_readable($template_file) || !filesize($template_file)) {
                    $this->_nl_error = true;
                    $this->_nl_last_error = NEWSLETTER_MSG_INVALID_SENDING_TEMPLATE . " \"$sending_template\"";
                    $this->outError();
                    $this->_output_tomainpanel($return_link);
                    return;
                } // if file_exists                

                $pagetocall .= "&newsletter_template=" . base64_encode($sending_template);


            } // if trim($sending_template
        } // if $nl['recipient_group']


        if (isset($_SESSION['PRISCILLA_SESSION']) && ($current_lang = $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang_content')) != '')
            $pagetocall .= "&swaplang=".$current_lang;

        $fp = fopen ($pagetocall, "r");
        if (!$fp)
        die("Fatal Error: unable to open \"$pagetocall\"\n");
        while (!feof($fp))
        $pagesource .= fread ($fp, $CHUNK);
        fclose ($fp);

        if (strpos($pagesource, "__NEWSLETTER_TEMPLATE_ERROR__") !== false) {
            $this->_nl_error = true;
            $this->_nl_last_error = NEWSLETTER_MSG_INVALID_SENDING_TEMPLATE . " \"$sending_template\"";
            $this->outError();
            $this->_output_tomainpanel($return_link);
            return;
        }

        // link da relativi ad assoluti

        // immagini
        $pagesource =
            preg_replace(
                ':<img (.*?)src=["\']((?!http\://).*?)["\']:i',
                '<img \\1 src="http://' . $server_basedir  .'/\\2"', $pagesource);

        // links: compresi fogli di stile e ad eccezione dei mailto
        $pagesource =
            preg_replace(
                ':<(.*?)href=["\']((?!(http\://|mailto\:|#)).*?)["\']:i',
                '<\\1 href="http://' . $server_basedir  .'/\\2"', $pagesource);


        if ($debug) {
            $debugfilename = $priscilla_local_path . "newsletter.html";

            $fdebug = fopen($debugfilename, "w");
            if (!$fdebug)
                die("Fatal Error: could not write debug file: '$debugfilename'");
            fwrite($fdebug, $pagesource);
            fclose($fdebug);
        }

    }


    // si vanno a prendere gli indirizzi aggiuntivi e li si verificano
    $testo_recipient = trim($nl['recipient']);
    $elenco_mail = array();
    $elenco_mail_totali = array();


    if ($testo_recipient != '') {

        $elenco_mail = explode(',', $testo_recipient);
        $elenco_mail = array_unique($elenco_mail);

        foreach ($elenco_mail as $current_mail) {
        // verifico la bonta' dell'indirizzo email
         if(!ereg("^[^@ ]+@[^@ ]+.[a-zA-Z]{2,4}$", $current_mail)) {
            $this->_nl_error = true;
            $this->_nl_last_error = NEWSLETTER_MSG_EMAIL_INVALID . ": " . "\"$current_mail\"";
            $this->outError();
            $this->_output_tomainpanel($return_link);
            return;
        }
        else $elenco_mail_totali[$current_mail] = $current_mail;
        } // foreach
    } // if ($testo_recipient

    if ($nl['recipient_group'] == -1) {
        $from = $nl['sender'];

        // in questo ci devono essere indirizzi buoni    
        if (!count($elenco_mail_totali)) {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_MSG_RECIPIENT_MISSING;
        $this->outError();
        $this->_output_tomainpanel($return_link);
        return;
        } // if (!count
    } else {

        // si e' scelto di inviare una newsletter: controllo della bonta'
        // ed estrazione dell'elenco degli indirizzi
        
        $this->_nl_error = false;
        $adesso_nl = time();

        $dbquery = "SELECT * FROM " . NEWSLETTER_TABLE_MAILGROUP . " WHERE gid = '$nl[recipient_group]'";
        $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());


        if ($rowrs->RecordCount() <= 0) {
            $this->_nl_error = true;
             $this->_nl_last_error = NEWSLETTER_MSG_NOT_FOUND_NEWSLETTER_ID . " = \"" . $nl[recipient_group] . "\"";
        } else {

            // si verificano i permessi
            if (!$this->hasNewsletterPermission($nl[recipient_group])) {
                $this->_nl_error = true;
                $this->_nl_last_error = NEWSLETTER_MSG_NEWSLETTER_PERMISSION_LACK . " = \"" . $nl[recipient_group] . "\"";
            }
            $from = $rowrs->fields('frommail');
            $newsletter_current_name = $rowrs->fields('name');
            $nltagpageid = $rowrs->fields('tagpageid');
            $unsubscribe_text = $rowrs->fields('unsubscribemsg');


            // nel caso di newsletter testuale si vede se e' il caso di aggiungere un messaggio per annullare la sottoscrizione
            if (trim($unsubscribe_text) != '') {

                if (strpos($unsubscribe_text, "{unsuburl}") === false) {
                    $this->_nl_error = true;
                    $this->_nl_last_error = NEWSLETTER_MSG_UNSUBURL_TAG;
                }

                if ($is_html_mail && strpos($pagesource, "[newsletterunsubmsg]") === false) {
                    $this->_nl_error = true;
                    $this->_nl_last_error = NEWSLETTER_MSG_UNSUBURL_TAG_HTML;
                }

                if ($this->_nl_error == false) {
                    if (!$nltagpageid) {
                        $this->_nl_error = true;
                        $this->_nl_last_error = NEWSLETTER_MSG_SUBSCRIBE_TAG;
                    }
                }

                if ($this->_nl_error == false) {
                    // se l'utente ha impostato una lingua (tabella di contenuto) diversa

                    if (isset($_SESSION['PRISCILLA_SESSION']) && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang_content') != ''
)
                        $content_base = $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang_content');
                    else {
                        $dbquery = "SELECT id, contenuto FROM node WHERE id = '" . $nltagpageid . "'";
                        $rspage = $this->_nl_connh->Execute($dbquery);
                        if (!$rspage || !$rspage->RecordCount()) {
                            $this->_nl_error = true;
                            $this->_nl_last_error = NEWSLETTER_MSG_SUBSCRIBE_TAG;
                        }
                        else
                            $content_base = $rspage->fields('contenuto');
                    }
                }

                if ($this->_nl_error == false) {
                    $dbquery = "SELECT id, contenuto FROM node WHERE id = '" . $nltagpageid . "'";
                    $rspage = $this->_nl_connh->Execute($dbquery);
                    if (!$rspage || !$rspage->RecordCount()) {
                        $this->_nl_error = true;
                        $this->_nl_last_error = NEWSLETTER_MSG_SUBSCRIBE_TAG;
                    }
                    else
                        $content_base = $rspage->fields('contenuto');
                }
            
                if ($this->_nl_error == false) {
                    $dbquery = "SELECT * FROM `$content_base` WHERE id = '" . $nltagpageid . "'";
                    $rspage = $this->_nl_connh->Execute($dbquery);
                    if (!$rspage || !$rspage->RecordCount()) {
                        $this->_nl_error = true;
                        $this->_nl_last_error = NEWSLETTER_SUBSCRIBE_TAG;
                    }
                    else {
                        $fdata = $rspage->fields;

                        $tofind1 = "{newsletteriscrizione id=\"" .  $nl['recipient_group'] . "\"}";
                        $tofind2 = "{newslettersubscribtion id=\"" .  $nl['recipient_group'] . "\"}";
                        $tagfound = false;

                        foreach ($fdata as $kf=>$kv) {

                            if (strpos(stripslashes($kv), $tofind1) !== false) {
                                $tagfound = true;
                                break;
                            }
                            if (strpos(stripslashes($kv), $tofind2) !== false) {
                                $tagfound = true;
                                break;
                            }
                        } // foreach
                        if (!$tagfound) {
                            $this->_nl_error = true;
                            $this->_nl_last_error = NEWSLETTER_MSG_SUBSCRIBE_TAG;
                        }
                    } // else
                }

                if ($this->_nl_error == false) {
                    $have_to_include_unsubscribe = true;
                    $nlid = $nl['recipient_group'];
                    $pageid = $nltagpageid;
                } // if
            } // if trim($rowrs->fields('unsubscribemsg'
        }

        // ritorno di eventuali errori
        if ($this->_nl_error) { 
            $this->outError();
            $this->_output_tomainpanel($return_link);
        return;
        }
    }

    // si controlla se la email del mittente &Egrave; valida
    if(!ereg("^[^@ ]+@[^@ ]+.[a-zA-Z]{2,4}$", $from)) {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_MSG_FROM_EMAIL_INVALID . ": \"" . $from . "\"";
        $this->outError();
        $this->_output_tomainpanel($return_link);
        return;
    }

    $adesso = time();

        $cgiorno = date("d", $adesso);
        $cmese = date("m", $adesso);
        $canno = date("Y", $adesso);

    $oggitime = mktime(0,0,0, $cmese, $cgiorno, $canno);


    if (isset($nl['daynotresend']) && $nl['daynotresend'] == 1)
        $query_add = " AND time_lastsent < '$oggitime'";
    else
        $query_add = '';

    // si va a prendere l'elenco delle email cui inviare

    if (isset($nl['sendnonactive']) && $nl['sendnonactive'] == 1)
        $astatus = "no";
    else
        $astatus = "yes";


    $max_month_size = 0;
    $dbquery = "SELECT `newslettermaxmonthsize` FROM `priscilla` WHERE `id` = 1 LIMIT 1";
    $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
 
    if ($rowrs->RecordCount() == 0) {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_MSG_NO_SIZE_LIMIT;
        $this->outError();
        $this->_output_tomainpanel($return_link);
        die("</body>\n</html>\n");
    }
    else $max_month_size = (int)$rowrs->fields('newslettermaxmonthsize');

    $yearmonth = date("Y-m");  
    $dbquery = "SELECT sizesent FROM `newsletter_counters` WHERE `yearmonth` = '$yearmonth' LIMIT 1";
    $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

    if ($rowrs->RecordCount() && (int)$rowrs->fields('sizesent') > $max_month_size && $max_month_size != 0) {
        $this->_output_tomainpanel($return_link);
        die("Fatal Error: " . "<h2>" . NEWSLETTER_ERROR_NOMORECREDITS . ".<h2>\n</body>\n</html>\n");
    }

    $dbquery =
        "SELECT id, email FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE idmailg = '$nl[recipient_group]' AND isactivestatus = '" . $astatus . "'" .
        $query_add;

    $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

    if ($rowrs->RecordCount() <= 0 && !count($elenco_mail_totali)) {
        $this->_nl_error = true;
        $this->_nl_last_error = NEWSLETTER_MSG_NO_EMAIL_ACTIVE;
        $this->outError();
        $this->_output_tomainpanel($return_link);
    }

   
    // qui si va a inviare
    while (!$rowrs->EOF) {
        $elenco_mail_totali[$rowrs->fields('id')] = $rowrs->fields('email');
        $rowrs->MoveNext();
    } // while


    if (!function_exists("GetMXRR")) {
        /*
         * If possible specify in this array the address of at least on local
         * DNS that may be queried from your network.
         */
         $_NAMESERVERS = array();
         include("../packages/stmp/getmxrr.php");
    }
    require("../packages/smtp/smtp.php");


 
    $smtp = new smtp_class;
    $smtp->host_name = $smtpconf['smtpserver']; /* relay SMTP server address */
    $smtp->localhost="localhost";           /* this computer address */
    $smtp->direct_delivery = 0;     /* Set to 1 to deliver directly to the recepient SMTP server */
    $smtp->debug = 0;           /* Set to 1 to output the communication with the SMTP server */
    $smtp->user = $smtpconf['smtpuser'];/* Set to the user name if the server requires authetication */
    $smtp->realm = $smtpconf['smtprealm'];      /* Set to the authetication realm, usually the authentication user e-mail doma in */
    $smtp->password = $smtpconf['smtppassw'];     /* Set to the authetication password */




    // controllo sulla bonta' del server che ci hanno fornito
    if (!$smtp->direct_delivery) {
        $fp = @fsockopen($smtp->host_name, 25, $errno, $error, 30);
        if (!$fp) {
            $this->_nl_error = true;        
            $this->_nl_last_error = NEWSLETTER_SMTP_RELAY_ERROR . ": \"". $smtp->host_name . "\"";
            $this->outError();
            $this->_output_tomainpanel($return_link);
            return;
        }
        else fclose($fp);
    }

    
    $total_mail = 0;
    $total_failed = 0;
    $total_sent = 0;
    $total_left = count($elenco_mail_totali);


    $l_panel_summary = NEWSLETTER_N_EMAIL_SENT . " | " . NEWSLETTER_N_EMAIL_FAILED . " | " . NEWSLETTER_N_EMAIL_LEFT;
    $l_summary_sent = NEWSLETTER_N_EMAIL_SENT;
    $l_summary_failed = NEWSLETTER_N_EMAIL_FAILED;
    $l_summary_left = NEWSLETTER_N_EMAIL_LEFT;
    
    $l_panel_lasterror = NEWSLETTER_LAST_ERROR;

    $empty_panel = sprintf(" %4s | %4s | %4s", "", "", "");

    if (isset($newsletter_current_name) && trim($newsletter_current_name) != '')
        $s_cname = $newsletter_current_name . ": ";
    else
        $s_cname = '';

    echo
        "<table width=\"70%\" align=\"CENTER\">\n" .
        "<tr>\n" .
        "<td align=\"CENTER\" class=\"button_out\">" .
        $s_cname .  NEWSLETTER_N_EMAIL_TOTAL . ": " . count($elenco_mail_totali) .
        "&nbsp;&nbsp;" .
        NEWSLETTER_WAITING_FOR_SENDING . " " . "5" . " " . NEWSLETTER_WAITING_FOR_SENDING_SECONDS .
        "</td>" .
        "</tr>" .
        "</table>\n";

echo <<< END
    <form name="fpanel">
    <table width="70%" align="CENTER">
    <tr>
    <td width="30%" align="CENTER" class="table_sez">
    SMTP = '$smtp->host_name'
    </td>
    <td width="70%" align="CENTER" class="table_sez">
    $l_summary_sent: <input readonly class="insert_area" type="TEXT" size="6" value="" name="mailstatus_sent">
    $l_summary_failed: <input readonly class="insert_area" type="TEXT" size="6" value="" name="mailstatus_failed">
    $l_summary_left: <input readonly class="insert_area" type="TEXT" size="6" value="" name="mailstatus_left">
    </td>
    </tr>
    <tr>
    <td width="30%" align="CENTER" class="table_sez">
    <input class="insert_area" type="TEXT" style="width:90%" name="mailerror">
    </td>
    <td width="70%" align="LEFT" class="table_sez">
    &nbsp;&nbsp;&lt;&lt;&nbsp;$l_panel_lasterror
    </td>
    </tr>
    </table>
END;

    
    flush();
    sleep(5);

    $failed_list = array();

    while (list($k, $v) = each($elenco_mail_totali)) {

        if ($have_to_include_unsubscribe) {
    
            $cunsubcode = md5($pageid . "2005" . $nlid . "2005" . $v);
            $expanded_url =
                "http://" .
                    $server_basedir .
                    "/modules/newsletter/lib/nlsubscribe.php?" .
                    "pid=" . $pageid . "&" .
                    "nlid=" . $nlid . "&" .
                    "remove=" . $v . "&" .
                    "c=" . $cunsubcode;

            if (!$is_html_mail)
                $pagesource_b = $pagesource . "\n" . str_replace("{unsuburl}", $expanded_url, $unsubscribe_text);
            else {
                $html_unsub_msg = str_replace("{unsuburl}", $expanded_url, $unsubscribe_text);
                $pagesource_b = str_replace("[newsletterunsubmsg]", $html_unsub_msg, $pagesource); 
            }
        }
        else
            $pagesource_b = $pagesource;


        $current_message_size = strlen($pagesource_b);

        $me = new MailEngine ($this->_nl_connh, $from, $v, $subject, $pagesource_b, $is_html_mail);
        $headers = $me->getMailHeaders();
        $message = $me->getMailMessage();


        $send_status_ok = $smtp->SendMessage($from, array($v), $headers, $message);
        unset($me);

        $total_mail++;
        $total_left--;

        $adesso = time();

        $errormsg = '';

        if ($send_status_ok) {
            $total_sent++;
            $dbquery = "UPDATE " . NEWSLETTER_TABLE_MAILDATA .
                " SET time_lastsent = '$adesso', nmailsent = nmailsent + 1 WHERE id = '$k'";

            // occorre aggiornare i contatori
            // che anno e' che mese e'
            $yearmonth = date("Y-m");

            $dbquerys = "SELECT `id`, `sizesent` FROM `newsletter_counters` WHERE `yearmonth` = '" . $yearmonth . "'";
            $rscounter = $this->_nl_connh->Execute($dbquerys);
            if (!$rscounter)
                die("Fatal Error: counters error (getsize: 1)");

            if ($rscounter->RecordCount() > 1)
                die("Fatal Error: counters error (getsize: 1)");

            if ($rscounter->RecordCount() == 0) {
                $sizesent = 0;
                $dbquerys = "INSERT INTO `newsletter_counters` (`yearmonth`, `sizesent`) VALUES ('$yearmonth', $current_message_size)";
                $rscounter_update = $this->_nl_connh->Execute($dbquerys);
                if (!$rscounter_update)
                    die("Fatal Error: counters error (insert size)");
            }
            else {
                $sizesent = (int)$rscounter->fields('sizesent');
                $dbquerys = "UPDATE `newsletter_counters` SET `sizesent` = `sizesent` + $current_message_size WHERE `id` = " . $rscounter->fields('id') . " LIMIT 1";
                $rscounter_update = $this->_nl_connh->Execute($dbquerys);
                if ((!$rscounter_update || $this->_nl_connh->Affected_Rows() != 1) && $max_month_size != 0)
                    die("Fatal Error: counters error (setsize)");
            }
            if ($max_month_size != 0 && $sizesent > $max_month_size) {
                $this->_output_tomainpanel($return_link);
                die("Fatal Error: " . "<h2>" . NEWSLETTER_ERROR_NOMORECREDITS . "<h2>\n</body>\n</html>\n");
            }
        }
        else {
            $errormsg = $smtp->error;
            $failed_list[] = $v;
            $total_failed++;
            $dbquery = "UPDATE " . NEWSLETTER_TABLE_MAILDATA .
                " SET nmailfailed = nmailfailed + 1 WHERE id = '$k'";
        }

 
        if ($errormsg != '')
            $errormsg = "document.forms.fpanel.mailerror.value = \"$v: $errormsg\";";

        // si esegue la query se l'email e' in tabella
        if (is_numeric($k))
        $this->_nl_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

        $summary = sprintf(" %4d | %4d | %4d", $total_sent, $total_failed,  $total_left);
        $summary_sent = sprintf("%4d", $total_sent);
        $summary_failed = sprintf("%4d", $total_failed);
        $summary_left = sprintf("%4d", $total_left);


        echo
        "\n<script>document.forms.fpanel.mailstatus_sent.value = \"$summary_sent\";" .
            "document.forms.fpanel.mailstatus_failed.value = \"$summary_failed\";" .
            "document.forms.fpanel.mailstatus_left.value = \"$summary_left\";" .
            "document.forms.fpanel.mailerror.value = \"$errormsg\";" .
            "</script>\n<noscript>err_js_not_supported</noscript>";
        flush();

    } // foreach


    if ($total_failed) {
        echo
        "<br /><br />" .
        "<table width=\"50%\" align=\"CENTER\">\n" .
        "<tr>\n" .
        "<td align=\"CENTER\" class=\"button_out\">" .
        NEWSLETTER_MSG_SENDING_ERROR .
        "</td>" .
        "</tr>\n";

        if (count($failed_list)) {
        echo "<tr><td align=\"CENTER\" class=\"insert_voice\">" .
            "<textarea READONLY class=\"insert_area\" rows=\"3\" style=\"width:100%\">\n";

        $s_failed = '';
        foreach ($failed_list as $fmail) {
            if ($s_failed == '')
            $s_failed = $fmail;
            else
            $s_failed .= ", " . $fmail;
        }
        echo $s_failed . "</textarea>\n</td></tr>";
        }


        if ($nl['recipient_group'] != -1)
        echo
        "<tr>\n" .
        "<td align=\"CENTER\" class=\"button_out\">" .
        NEWSLETTER_MSG_RESENDING_NOTE .
        "</td>" .
        "</tr>\n";


        echo
        "</table><br /><br />\n";
    }

    // aggiorno data di ultimo invio newsletter
    if ($nl['recipient_group'] != -1) {
        $dbquery = "UPDATE " . NEWSLETTER_TABLE_MAILGROUP . " SET nl_lastsent = '$adesso_nl' WHERE gid = '$nl[recipient_group]'";
        $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
    }


    // torno al pannello principale o alla pagina da cui si e' spedito
    $this->_output_tomainpanel($return_link);
    
    } // handleNewsletterSending

    function hasNewsletterPermission ($gid) {

    if ($this->_nl_user == 'superuser')
        return true;

    $dbquery = "SELECT user FROM " . NEWSLETTER_TABLE_MAILGROUP . " WHERE gid = '$gid'";
    $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

    if ($rowrs->RecordCount() > 0)
        if ($rowrs->fields('user') == $this->_nl_user)
        return true;

    return false;
    } // hasNewsletterPermission

    function outputJSForm () {

    $l_newsletter_delete_confirm = NEWSLETTER_MSG_NEWSLETTER_DELETE_CONFIRM;

    $l_newsletter_sending_confirm =
        NEWSLETTER_MSG_SENDING_CONFIRM . '\n\n' .
        NEWSLETTER_MSG_SENDING_CONFIRM_JS_ALERT;

echo <<< END

    <script LANGUAGE="Javascript" type="text/javascript">
    function nle (nl_id, nl_action) {
        if (nl_action == 'd')
        if (!confirm('$l_newsletter_delete_confirm' + ' ' + nl_id + '?'))
            return; 
        document.forms.fnlmodify.fnledit.value = nl_action;
        document.forms.fnlmodify.fnlid.value = nl_id;
        document.forms.fnlmodify.submit();
    }

    function order (fieldname) {
        document.forms.fnewsletterinfo.neworderby.value = fieldname;
        document.forms.fnewsletterinfo.submit();
    }

        function sending_warn () {
        if (!confirm('$l_newsletter_sending_confirm'))
        return false;
        }


    </script>
    <noscript>err_js_not_supported</noscript>
    <form name="fnlmodify" action="$_SERVER[PHP_SELF]" method="POST">
    <input type="hidden" name="fnlid" />
    <input type="hidden" name="fnledit" />
    </form>
END;
    }

    function _output_group_list() {

    $m_no_newsletter_found = NEWSLETTER_MSG_NO_NEWSLETTER;
    $l_newsletter_select = NEWSLETTER_NEWSLETTER_SELECT;

    if ($this->_nl_user != 'superuser')
        $add_query_part = " WHERE user = '$this->_nl_user'";
    else
        $add_query_part = '';


    $dbquery = "SELECT gid, name FROM " . NEWSLETTER_TABLE_MAILGROUP . $add_query_part . " ORDER BY `name` ASC";
    $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
    
    if ($rowrs->RecordCount() <= 0)
        echo $m_no_newsletter_found;
    else {
        echo
        "<select class=\"insert_area\" name=\"newsletter[recipient_group]\" size=\"1\">\n" .
        "<option value=\"-1\">" . ">>> " . $l_newsletter_select . " <<<" . "</option>\n";
        
        while (!$rowrs->EOF) {
        $row = $rowrs->fields;
        echo "<option value=\"$row[gid]\">$row[name] (" . $row['gid'] . ")</option>\n";
        $rowrs->MoveNext();
        }
        echo "</select>\n";
    }
    
    } // _output_group_list

    
    function _output_page_list ($objname='', $pageid = 0) {


    if ($objname == '')
        $selname = "newsletter[pageid]";
    else
        $selname = $objname;

    $m_no_page_found = NEWSLETTER_NO_HTML_PAGE;

    // stampa le pagine pubbliche di questo user oppure tutte (sempre pubbliche) per superuser

    if ($this->_nl_user != 'superuser')
        $add_query = " WHERE id_user = '" . $this->_nl_user . "'";

    $dbquery = "SELECT id, sezione FROM " . PRISCILLA_TABLE_NODE . $add_query;
    $dbquery .= " ORDER BY sezione ASC";

    $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

    if ($rowrs->RecordCount() <= 0) {
        echo $m_no_page_found;
        echo "<input type=\"HIDDEN\" name=\"$selname\" value=\"-1\">\n";
    }
    else {

        echo
        "<select class=\"insert_area\" name=\"$selname\" size=\"1\">\n";

        if ($objname == '')
            echo "<option value=\"-1\">" . ">>> " . NEWSLETTER_SENDING_TEXT_EMAIL . " <<<" . "</option>\n";
        else
            echo  "<option value=\"0\">" . "</option>\n";

        while (!$rowrs->EOF) {
        $row = $rowrs->fields;

        if ($row['id'] == $pageid)
            $selval = "selected";
        else
            $selval = "";

        if (strlen($row['sezione']) > 50)
            $row['sezione'] = substr($row['sezione'], 0, 50) . "....";
        else
            $row['sezione'] = $row['sezione'];



        echo "<option $selval value=\"" . $row['id'] . "\">" . strtoupper($row['sezione']) . " (" . $row['id'] . ")" . "</option>\n";
        $rowrs->MoveNext();
        } // while

        echo "</select>\n";
    }

    } // _output_page_list()


    function _output_template_list ($objname, $selected_name = '') {


        $template_list[] = "";


        $template_dir = "../templates";
        $handle = opendir($template_dir);

        while (false !== ($currtemplate = readdir($handle)))
            if (!ereg('^\.', $currtemplate) && is_file($template_dir . "/" . $currtemplate))
                $template_list[] = $currtemplate;
                    
        closedir($handle);

        sort($template_list);

        echo "<select class=\"insert_area\" name=\"$objname\" size=\"1\">\n";

        foreach ($template_list as $currtemplate) {

            if ($currtemplate == $selected_name)
                $selval = "selected";
           else
               $selval = "";

           echo "<option $selval value=\"" . $currtemplate . "\">" . $currtemplate . "</option>\n";
        } // foreach


        echo "</select>\n";        

    } // _output_template_list

    function _output_tenda_owner ($curr) {

    $sres = '';

    // si va a prendere la lista degli utenti priscilla
    $dbquery = "SELECT username, nome FROM user WHERE sospeso = 'no'";
    $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

    if ($rowrs->RecordCount() > 0) {
        $sres = "<select name=\"newsletter[owner]\" size=\"1\" class=\"insert_area\">\n";

        while (!$rowrs->EOF) {
        $row = $rowrs->fields;
        $is_selected = $row['username'] == $curr ? 'SELECTED' : '';
        $sres .= "<option $is_selected value=\"" . $row['username'] . "\">" . $row['username'] . "</option>\n";
        $rowrs->MoveNext();
        } // while

        $sres .= "</select>\n";
    } // if

    return $sres;
    } // _output_tenda_owner


    function _output_message ($msg) {
        echo
            "<div class=\"insert_message\" align=\"CENTER\"><strong>" .
            $msg .
            "</strong></div>\n";
    } // _output_message

    function _mail_exists_in_list ($gid, $email) {


        // verifico che l'email non ci sia gia'
        $dbquery =
        "SELECT id FROM " . NEWSLETTER_TABLE_MAILDATA . " WHERE idmailg = '$gid' AND LOWER(email) = '" . strtolower($email) . "'";
        $rowrs = $this->_nl_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());
        if ($rowrs->RecordCount() > 0)
        return true;

    return false;
    } // _mail_exists_in_list

    function _build_navigation_panel($position, $position_max, $item_total, $showlimit) {
        
        $page_total = ceil($item_total / $showlimit);
        $page_current = floor($position / $showlimit) + 1; 

        if (!$position) {
            $init_disabled = 'DISABLED';
            $rewind_disabled = 'DISABLED';
        }
        else {
            $init_disabled = '';
            $rewind_disabled = '';          
        }

        if ($position == $position_max) {
            $end_disabled = 'DISABLED';
            $forward_disabled = 'DISABLED';
        }
        else {
            $end_disabled = '';
            $forward_disabled = '';         
        }

        return
            "<input class=\"button_in\" $init_disabled type=\"SUBMIT\" name=\"newsletter[navigation_init]\" value=\"<<\">" . "&nbsp;" .
            "<input class=\"button_in\" $forward_disabled type=\"SUBMIT\" name=\"newsletter[navigation_forward]\" value=\">\">" . "&nbsp;" .
            "<input class=\"button_in\" $rewind_disabled type=\"SUBMIT\" name=\"newsletter[navigation_rewind]\" 
VALUE=\"<\">" . "&nbsp;" .
            "<input class=\"button_in\" $end_disabled type=\"SUBMIT\" name=\"newsletter[navigation_end]\" value=
\">>\">" . "&nbsp;" .
            NEWSLETTER_LABEL_NAVIGATION_PAG . "&nbsp;$page_current&nbsp;/&nbsp;$page_total";
    } // _build_navigation_panel


    function _output_showlimit_selection ($oldval) {

    if (!isset($oldval) || !is_numeric($oldval))
        $oldval = NEWSLETTER_NMAIL_PER_PAGE;


        echo "<select class=\"insert_area\" size=\"1\" name=\"newsletter[showlimit]\" onchange=\"document.forms.fnewsletterinfo.submit();\">\n";

        $limit_list = array ('1', '2', '3', '4', '5', '10', '15', '20', '30', '50');

        foreach ($limit_list as $currval) {
            $issel = $oldval == $currval ? 'SELECTED' : '';
            echo "<option $issel value=\"$currval\">" . $currval . "</option>\n";
        }
        $issel = !$oldval ? 'SELECTED' : '';
        echo "<option $issel value=\"0\">" . NEWSLETTER_EMAIL_ALL . "</option>\n";
        echo "</select>\n";
    } // _output_showlimit_selection


    function _output_yesno_select ($oldval) {

    	if (trim($oldval) == '')
            $oldval = "__all__";

        echo "<select class=\"insert_area\" size=\"1\" name=\"newsletter[yesnoselect]\" onchange=\"document.forms.fnewsletterinfo.submit();\">\n";

        $vlist = array (
		NEWSLETTER_EMAIL_ALL => "__all__",
		NEWSLETTER_YES => "yes",
		NEWSLETTER_NO => "no"
	);

        foreach ($vlist as $label=>$currval) {
            $issel = $oldval == $currval ? 'SELECTED' : '';
            echo "<option $issel value=\"$currval\">" . $label . "</option>\n";
        }
        echo "</select>\n";
    }

    function _output_tomainpanel ($return_link = '') {

    
        if ($return_link == '')
            echo
                "<br /><div align=\"center\"><a href=\"" . $_SERVER['PHP_SELF'] . "\">" . NEWSLETTER_TO_MAIN_PANEL . "</a></div>\n";
        else
             echo
                "<br /><div align=\"center\"><a href=\"" . $return_link . "\">" . NEWSLETTER_TO_SITE_PAGE . "</a></div>\n";
    } // _output_tomainpanel


    function _getAreeTematiche() {

        $a_aree = array();

        $dbquery = "SELECT DISTINCT areatematica FROM `node` WHERE areatematica != '' AND areatematica IS NOT NULL ORDER by `areatematica` ASC";
        $rowrs = $this->_nl_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

        if ($rowrs->RecordCount() > 0)
            while (!$rowrs->EOF) {
                $a_aree[] = $rowrs->fields('areatematica');
                $rowrs->MoveNext();
            } // while

        return $a_aree;
    }


    function _getSavedNewsletters ($current_area) {

        $a_saved_newsletters = array();

        if ($this->_nl_user != 'superuser')
            $add_query = " AND user = '" . $this->_nl_user . "'";
        else
            $add_query = "";

        //$dbquery = "SELECT * FROM `newsletter_compose_saved` WHERE `newslettername` LIKE '%" . str_replace(" ", "_", $current_area) . "%' " . $add_query  . " ORDER BY `id` DESC";
        $dbquery = "SELECT * FROM `newsletter_compose_saved` WHERE `newslettername` LIKE '%" . $this->clear_specials($current_area, '') . "%' " . $add_query  . " ORDER BY `id` DESC";

        $rowrs = $this->_nl_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());


        if ($rowrs->RecordCount() > 0)
            while (!$rowrs->EOF) {
                $a_saved_newsletters[$rowrs->fields('id')] = $rowrs->fields('newslettername');
                $rowrs->MoveNext();
            } // while

    return $a_saved_newsletters;
    } // _getSavedNewsletters


    function _getNewsletterSaved ($idnl) {

        $a_data = array();

        $dbquery = "SELECT * FROM `newsletter_compose_saved` WHERE id = '" . $idnl . "' LIMIT 1";

         $rowrs = $this->_nl_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_nl_connh->ErrorMsg());

        if ($rowrs->RecordCount())
            $row = $rowrs->fields;

        // una trasformazione per nomu campi da POS
        $a_data['compose_include_page'] = unserialize(bzdecompress(base64_decode($row['newsletternewslist'])));
        $a_data['compose_abstract'] = unserialize(bzdecompress(base64_decode($row['newsletterabstracts'])));

        $df = explode("-", $row['newsletterdatestart']);
        $dt = explode("-", $row['newsletterdateend']);

        $a_data['datafrom_year'] = $df[0];
        $a_data['datafrom_month'] = $df[1];
        $a_data['datafrom_day'] = $df[2];

        $a_data['datato_year'] = $dt[0];
        $a_data['datato_month'] = $dt[1];
        $a_data['datato_day'] = $dt[2];

        $a_data['compose_header'] = $row['newsletterheader'];
        $a_data['compose_footer'] = $row['newsletterfooter'];
        $a_data['compose_newsletterdesc'] = $row['newsletterdesc'];

    return $a_data;
    } // _getNewsletterSaved

    function _wraplines($oldstr, $wrap) {

        $newstr = "";
        $newline = "";
        $oldstr .= "\n";

        do {
        if (strpos($oldstr, "\n") <= $wrap)
        $i = strpos($oldstr, "\n");
            else {
        $i = $wrap;
        while (!ereg("[\n\t ]", substr($oldstr, $i, 1)) && $i > 0)
            $i--;
            }
            $newline = substr($oldstr, 0, $i + 1);
            if ($i != 0)
        $newline[$i] = "\n";
            if ($oldstr[0] != "")
        $oldstr = substr($oldstr, $i + 1);
            $newstr .= $newline;
        }
    while (strlen($oldstr) > 0);

        $newstr = substr($newstr, 0, -1);

    return $newstr;
    } // _wraplines


    function outError() {

        if ($this->_nl_error == true) {
            $this->_nl_error = false;

            if ($this->_nl_last_error != '')
                $errmsg = $this->_nl_last_error;
            else
                $errmsg = "UNKNOWN ERROR";

            echo "<br /><div align=\"CENTER\" class=\"insert_message\"><strong>" . $errmsg . "<br />" . $notemsg . "</strong></div><br /><br />";

            $this->_nl_last_error = '';
        }
    } 

    // funzione "rubata" da lib/functions.inc.php
    function clear_specials($stringa, $tail) {
        $stringa = trim($stringa);
        $stringa = strip_tags($stringa);
        $stringa = strtr($stringa, 'áàäåâßçéèëíìïîñóòöôøúùüûÁÀÄÅÂÇÉÈËÍÌÏÎÑÓÒÖÔØÚÙÜÛ', 'aaaaabceeeiiiinooooouuuuAAAAACEEEIIIINOOOOOUUUU');
        $stringa = strtolower($stringa);
        $stringa = preg_replace("/&\w+;/", '', $stringa);
        $stringa = preg_replace("/\W+/", '_', $stringa);
        $stringa = $stringa . $tail;
        return $stringa;
    }


} // class Newsletter


?>
