<?
// $Id: search_loop.inc.php,v 1.3 2010-08-30 07:43:35 calicant Exp $

$lang = 'eng';

require_once PRISCILLA_LOCAL_PATH."modules/search/lang/$lang/search.diz";

//----------------------------------------------------------------------
 // RISULTATI RICERCA
//----------------------------------------------------------------------
/**
 ** tag: risultatiricerca
 ** desc: stampa i risultati di una ricerca
 ** desc: i campi {id_sez}, {sez} e {string} possono essere richiamati all'interno del tag loop
 ** desc: e rappresentano l'id della pagina, il titolo e la porzione di testo che corrisponde alla ricerca
 ** opt: noparse (y|n) se posto a y non interpreta codice html eventualmente presente in "string"
 ** eg: <%risultatiricerca noparse="y"%>
 ** eg: <a href="index.php?id={id_sez}" class="menu" >{sez}</a>
 ** eg: <div>{string}</div>
 ** eg: <%end%>
 ** eg:
 ** eg: se Priscilla e' impostata con pagine con titoli in navigazione
 ** eg: usare {page} per i link di pagina:
 ** eg: <a href="{page}">{sez}</a>
 **/
function risultatiricerca (&$connh, $content, $risoluzione, &$PRISCILLA_SESSION, $tagparam, &$publisher, $blocco)
{

    if (defined("PRISCILLA_SEO_PAGE") AND PRISCILLA_SEO_PAGE == true)
        $have_seo = true;
    else
        $have_seo = false;

    $a_cat_index = array();

    if (isset($PRISCILLA_SESSION) && $PRISCILLA_SESSION->exists('priscilla_search_res')) {

        $priscilla_search_res = $PRISCILLA_SESSION->getvalue('priscilla_search_res');
        $priscilla_search_id = $PRISCILLA_SESSION->getvalue('priscilla_search_id');


        if (!is_array($priscilla_search_id) || count($priscilla_search_id) < 1) {
            // traduciamo questo unico messaggio
            $priscilla_search_res = array('string' => err_finder_resultsno);
            $publisher->publish($blocco, $risoluzione, $priscilla_search_res);
        }
        else
        {
            // adesso tutte le info di cui abbiamo bisogno sono in $priscilla_search_res = array (text, id, sez)
            for ($i = 0; $i < count($priscilla_search_res); $i++)
            {
                $rowR['id_sez']   = $priscilla_search_res[$i][1]; // sez id
                $rowR['sez']      = $priscilla_search_res[$i][2]; // sez title
                $rowR['string']   = $priscilla_search_res[$i][0]; // search summary



                if ($have_seo) {
                    // abbiamo un risultato di catalogo
                    if (strpos($rowR["id_sez"], "-") !== false) {

                        $a_cat_ids = explode("-", $rowR["id_sez"]);
                        $cat_scheda_id = $a_cat_ids[0]; 
                        $cat_id = $a_cat_ids[1];
                        $cat_page_id = $a_cat_ids[2];

                        if (!isset($a_cat_index[$cat_id])) {
                            require_once PRISCILLA_LOCAL_PATH . "modules/catalogo/lib/catalog.lib.php";
                            $a_cat_index[$cat_id] = make_index_for_catalog_pages($cat_id);
                        }
                        
                        $rowR["page"] = "index.php?id=$cat_page_id&cat_vis_start=" . $a_cat_index[$cat_id][$cat_scheda_id] . "#s" . $cat_scheda_id;
                    }
                    // non catalogo
                    else
                        $rowR["page"] = maketitle($rowR["id_sez"],  seotitle($rowR["sez"]));
                }

                if ($tagparam[$tagstring1]['noparse'] == 'y')
                    $rowR['string'] = htmlentities($rowR['string'], ENT_COMPAT, PRISCILLA_CHARSET);

                // si impedisce di risolvere i tag
                $rowR['string'] = str_replace("{", "{ ", $rowR['string']);
                $rowR['string'] = str_replace("}", " }", $rowR['string']);
                //$rowR['string'] = str_replace("<%", "< %", $rowR['string']);
                //$rowR['string'] = str_replace("%>", "% >", $rowR['string']);

                $publisher->publish($blocco, $risoluzione, $rowR);


            } // for
        }

        $PRISCILLA_SESSION->remove('priscilla_search_res');
        $PRISCILLA_SESSION->remove('priscilla_search_id');
        $PRISCILLA_SESSION->remove('priscilla_search_sez');
        $PRISCILLA_SESSION->remove('priscilla_search_params');

        unset($priscilla_search_res);
        unset($priscilla_search_id);

    }
}

?>
